Program BJC;

{$M 64000,250000,655360}

{$N-}

{

BJ-Commander!
*************

Ein kleiner Norton-Commander-Clone.
Cooooool.

}

Uses
  Crt, Dos, FastText, Sprite, Pic_OS, Video;

Type

  Bloed = Record                     { Datei-Informationen }
               Name: String[8];      { Dateiname }
               Extens: String[3];    { Datei-Erweiterung }
               Attr: Byte;           { Attribute }
               FSize: LongInt;       { Datei-Gre }
               Year,Month,Day: Word; { Datei-Datum }
               Marker:Boolean;       { Markiert? }
            End;

  UnterMenuRec = Record        { Fr Untermens }
             Cap: String[16];  { Bezeichnung }
             Nr: Word;         { Eine willkrliche Nummer zur Identifikation }
             Marked: Byte;     { Welcher Buchstabe markiert ist }
             Short: Char;      { Der Buchstabe selbst }
             x: Byte;          { In welcher Spalte Darstellung beginnt }
             Width: Byte;      { Wie Breit das Men-Fenster ist }
             AnzMenuPunkte,    { Wieviele Menupunkte }
             AktMenuPunkt,     { Welcher gerade gewhlt ist }
             StartX: Byte;     { Wo das Untermen-Fenster beginnt (X-Richtung) }
  End;

  MenuPunktRec = Record        { Fr Menu-Punkte }
             Cap: String[32];  { s.o. }
             Hot: String[12];  { Beschr. fr Hotkey }
             Key: Char;        { Der Tasten-Code des Hotkeys (NUR ERWEITERT!) }
             Nr: Word;         { s.o. }
             SubNr: Word;      { Nummer des Untermens, in dem sich dieser Menpunkt befindet }
             Checked: Boolean; { Ob markiert, oder nicht }
             Marked: Byte;     { s.o. }
             Short: Char;      { s.o. }
             MenuNummer: Word; { Fr sptere Adressierung }
  End;

  { Daten fr die Uhr }
  UhrXYVFHF = Record
               PositionX,PositionY:Integer;
               FarbeVordergrund,FarbeHintergrund:Byte;
              End;

Const
  Ver = '1.2';            { Versionsnummer (gaaaaanz wichtig) }

  MaxDateien=2600;        { Wieviele Dateien maximal eingelesen werden knnen }
  MaxDateienScreen = 21;  { Wieviele Dateien dargstellt werden }
  DateiStart = 2;         { In welcher Zeile die Darstellung beginnt }

  { Tastatur-Konstanten... }
  Taste_Nix = #0;
  Taste_PfeilOben = #72;
  Taste_PfeilUnten = #80;
  Taste_PfeilLinks = #75;
  Taste_PfeilRechts = #77;
  Taste_SeiteOben = #73;
  Taste_SeiteUnten = #81;
  Taste_Pos1 = #71;
  Taste_Ende = #79;
  Taste_Eingabe = #13;
  Taste_Leer = #32;
  Taste_Esc = #27;
  Taste_Tab = #9;
  Taste_F1 = #59;
  Taste_F2 = #60;
  Taste_F3 = #61;
  Taste_F4 = #62;
  Taste_Alt_F4 = #107;
  Taste_Alt_F1 = #104;
  Taste_Alt_F2 = #105;
  Taste_Strg_F1 = #94;
  Taste_Strg_F2 = #95;
  Taste_Shift_F1 = #84;
  Taste_Shift_F2 = #85;
  Taste_Loeschen = #8;
  Taste_F5 = #63;
  Taste_F6 = #64;
  Taste_F7 = #65;
  Taste_F8 = #66;
  Taste_F9 = #67;
  Taste_F10 = #68;
  Taste_AltX = #45;
  Taste_Alt_A = #30;
  Taste_Alt_N = #49;
  Taste_Alt_U = #22;
  Taste_Alt_G = #34;
  Taste_Alt_R = #19;
  Taste_Alt_W = #17;

  { Farbkonstanten... }
  Vordergrund = White;
  Hintergrund = Blue;
  Markiert = Yellow;
  Balken = Cyan;
  SchriftNormal = White;
  FensterNormal = LightGray;
  Ueberschrift = Yellow;
  MenuVorder = White;
  MenuHinter = Cyan;
  MenuMarkiert = Yellow;
  MenuBalken = Black;

  {Angaben zur Uhr auf dem Bildschirm}
  UhrX=72;
  UhrY=24;
  UhrVF=White;
  UhrHF=Blue;

  { Erlaubte Zeichen fr Dateinamen: }
  SuchZeichen = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ!_-{}()[]%&$"/*+<>|^.';

  { ID-Nummern fr Untermens: }
  MLinks     = 0;
  MDatei     = 1;
  MRechts    = 2;
  MExtras    = 3;
  MAuswahl   = 4;

  { ID-Nummern fr Menpunkte: }
  PNameL     = 0;
  PExtensL   = 1;
  PSizeL     = 2;
  PNameR     = 4;
  PExtensR   = 5;
  PSizeR     = 6;
  PCopy      = 8;
  PMove      = 9;
  PRename    = 10;
  PDelete    = 11;
  PBeenden   = 12;
  PLine1     = 13;
  PLine2     = 14;
  PLine3     = 15;
  PFilterL   = 16;
  PFilterR   = 17;
  PDriveL    = 18;
  PDriveR    = 19;
  PNoFilterL = 20;
  PNoFilterR = 21;
  PLine4     = 22;
  PLine5     = 23;
  PSetRead   = 24;
  PSetHidden = 25;
  PSetSystem = 26;
  PSetArchive= 27;
  PClrRead   = 28;
  PClrHidden = 29;
  PClrSystem = 30;
  PClrArchive= 31;
  PLine6     = 32;
  PLine7     = 33;
  PLine8     = 34;
  PMarkAll   = 35;
  PMarkNone  = 36;
  PMarkInvert= 37;
  PNewDir    = 38;
  PLine9     = 39;
  PLine10    = 40;
  PActL      = 41;
  PActR      = 42;
  PTextView  = 43;
  PFileInfo  = 44;
  PDriveInfo = 45;
  PPicView   = 46;
  PLine11    = 47;
  PAbout     = 48;
  PMakeList  = 49;
  PGrpSel    = 50;
  PGrpUnSel  = 51;
  PGrpRepeat = 52;

  { Konstanten fr Men }
  MenuStart = 0;
  AnzUnterMenus = 4;
  AnzMenuPunkteGesamt = 50;

  UnterMenus: Array[0..AnzUnterMenus] Of UnterMenuRec =
              (
               (Cap:'~Links'; Nr:MLinks),
               (Cap:'~Datei'; Nr:MDatei),
               (Cap:'~Auswahl'; Nr:MAuswahl),
               (Cap:'~BJ-Extras'; Nr:MExtras),
               (Cap:'~Rechts'; Nr:MRechts)
              );

  MenuPunkte: Array[0..AnzMenuPunkteGesamt] Of MenuPunktRec =
             (
              { Men "Links": (Nummer 0) }
              (Cap:'Nach ~Name'; Hot:''; Key:Taste_Nix; Nr:PNameL; SubNr:MLinks; Checked:True),
              (Cap:'Nach ~Erweiterung'; Hot:''; Key:Taste_Nix; Nr:PExtensL; SubNr:MLinks; Checked:False),
              (Cap:'Nach ~Gre'; Hot:''; Key:Taste_Nix; Nr:PSizeL; SubNr:MLinks; Checked:False),
              (Cap:'-'; Hot:''; Key:Taste_Nix; Nr:PLine2; SubNr:MLinks; Checked:False),
              (Cap:'A~ktualisieren'; Hot:'F1'; Key:Taste_F1; Nr:PActL; SubNr:MLinks; Checked:False),
              (Cap:'-'; Hot:''; Key:Taste_Nix; Nr:PLine9; SubNr:MLinks; Checked:False),
              (Cap:'~Filter...'; Hot:'Strg+F1'; Key:Taste_Strg_F1; Nr:PFilterL; SubNr:MLinks; Checked:False),
              (Cap:'Filter ~aufheben'; Hot:'Shift+F1'; Key:Taste_Shift_F1; Nr:PNoFilterL; SubNr:MLinks; Checked:False),
              (Cap:'-'; Hot:''; Key:Taste_Nix; Nr:PLine4; SubNr:MLinks; Checked:False),
              (Cap:'~Laufwerk...'; Hot:'Alt+F1'; Key:Taste_Alt_F1; Nr:PDriveL; SubNr:MLinks; Checked:False),
              { Menu "Rechts": (Nummer 2) }
              (Cap:'Nach ~Name'; Hot:''; Key:Taste_Nix; Nr:PNameR; SubNr:MRechts; Checked:True),
              (Cap:'Nach ~Erweiterung'; Hot:''; Key:Taste_Nix; Nr:PExtensR; SubNr:MRechts; Checked:False),
              (Cap:'Nach ~Gre'; Hot:''; Key:Taste_Nix; Nr:PSizeR; SubNr:MRechts; Checked:False),
              (Cap:'-'; Hot:''; Key:Taste_Nix; Nr:PLine3; SubNr:MRechts; Checked:False),
              (Cap:'A~ktualisieren'; Hot:'F2'; Key:Taste_F2; Nr:PActR; SubNr:MRechts; Checked:False),
              (Cap:'-'; Hot:''; Key:Taste_Nix; Nr:PLine10; SubNr:MRechts; Checked:False),
              (Cap:'~Filter...'; Hot:'Strg+F2'; Key:Taste_Strg_F2; Nr:PFilterR; SubNr:MRechts; Checked:False),
              (Cap:'Filter ~aufheben'; Hot:'Shift+F2'; Key:Taste_Shift_F2; Nr:PNoFilterR; SubNr:MRechts; Checked:False),
              (Cap:'-'; Hot:''; Key:Taste_Nix; Nr:PLine5; SubNr:MRechts; Checked:False),
              (Cap:'~Laufwerk...'; Hot:'Alt+F2'; Key:Taste_Alt_F2; Nr:PDriveR; SubNr:MRechts; Checked:False),
              { Menu "Dateien": (Nummer 1) }
              (Cap:'~Kopieren...'; Hot:'F5'; Key:Taste_F5; Nr:PCopy; SubNr:MDatei; Checked:False),
              (Cap:'~Verschieben...'; Hot:'F6'; Key:Taste_F6; Nr:PMove; SubNr:MDatei; Checked:False),
              (Cap:'~Umbennen...'; Hot:'F7'; Key:Taste_F7; Nr:PRename; SubNr:MDatei; Checked:False),
              (Cap:'~Lschen'; Hot:'F8'; Key:Taste_F8; Nr:PDelete; SubNr:MDatei; Checked:False),
              (Cap:'N~eues Verzeichnis...'; Hot:'F9'; Key:Taste_F9; Nr:PNewDir; SubNr:MDatei; Checked:False),
              (Cap:'-'; Hot:''; Key:Taste_Nix; Nr:PLine1; SubNr:MDatei; Checked:False),
              (Cap:'~ReadOnly-Flag setzen'; Hot:''; Key: Taste_Nix; Nr:PSetRead; SubNr:MDatei; Checked:False),
              (Cap:'~Hidden-Flag setzen'; Hot:''; Key: Taste_Nix; Nr:PSetHidden; SubNr:MDatei; Checked:False),
              (Cap:'~System-Flag setzen'; Hot:''; Key: Taste_Nix; Nr:PSetSystem; SubNr:MDatei; Checked:False),
              (Cap:'~Archive-Flag setzen'; Hot:''; Key: Taste_Nix; Nr:PSetArchive; SubNr:MDatei; Checked:False),
              (Cap:'-'; Hot:''; Key:Taste_Nix; Nr:PLine6; SubNr:MDatei; Checked:False),
              (Cap:'Read~Only-Flag lschen'; Hot:''; Key: Taste_Nix; Nr:PClrRead; SubNr:MDatei; Checked:False),
              (Cap:'Hi~dden-Flag lschen'; Hot:''; Key: Taste_Nix; Nr:PClrHidden; SubNr:MDatei; Checked:False),
              (Cap:'S~ystem-Flag lschen'; Hot:''; Key: Taste_Nix; Nr:PClrSystem; SubNr:MDatei; Checked:False),
              (Cap:'Ar~chive-Flag lschen'; Hot:''; Key: Taste_Nix; Nr:PClrArchive; SubNr:MDatei; Checked:False),
              (Cap:'-'; Hot:''; Key:Taste_Nix; Nr:PLine8; SubNr:MDatei; Checked:False),
              (Cap:'~Beenden'; Hot:'Alt+X'; Key:Taste_AltX; Nr:PBeenden; SubNr:MDatei; Checked:False),
              { Menu "BJ-Extras": (Nummer 3) }
              (Cap:'~Textbetrachter...'; Hot:'F3'; Key:Taste_F3; Nr:PTextView; SubNr:MExtras; Checked:False),
              (Cap:'~Verzeichnis-Info...'; Hot:'F4'; Key:Taste_F4; Nr:PFileInfo; SubNr:MExtras; Checked:False),
              (Cap:'~Laufwerks-Info...'; Hot:'Alt+F4'; Key:Taste_Alt_F4; Nr:PDriveInfo; SubNr:MExtras; Checked:False),
              (Cap:'~Bildbetrachter'; Hot:'Return'; Key:Taste_Nix; Nr:PPicView; SubNr:MExtras; Checked:False),
              (Cap:'LST-Datei ~erstellen'; Hot:''; Key:Taste_Nix; Nr:PMakeList; SubNr:MExtras; Checked:False),
              (Cap:'-'; Hot:''; Key:Taste_Nix; Nr:PLine11; SubNr:MExtras; Checked:False),
              (Cap:'~ber...'; Hot:''; Key:Taste_Nix; Nr:PAbout; SubNr:MExtras; Checked:False),
              { Menu "Auswahl": (Nummer 4) }
              (Cap:'~Alles markieren'; Hot:'Alt+A'; Key:Taste_Alt_A; Nr:PMarkAll; SubNr:MAuswahl; Checked:False),
              (Cap:'~Nichts markieren'; Hot:'Alt+N'; Key:Taste_Alt_N; Nr:PMarkNone; SubNr:MAuswahl; Checked:False),
              (Cap:'Markierung ~umkehren'; Hot:'Alt+U'; Key:Taste_Alt_U; Nr:PMarkInvert; SubNr:MAuswahl; Checked:False),
              (Cap:'-'; Hot:''; Key:Taste_Nix; Nr:PLine7; SubNr:MAuswahl; Checked:False),
              (Cap:'~Gruppenauswahl...'; Hot:'Alt+G'; Key:Taste_Alt_G; Nr:PGrpSel; SubNr:MAuswahl; Checked:False),
              (Cap:'Gruppeauswahl ~rckgngig...'; Hot:'Alt+R'; Key:Taste_Alt_R; Nr:PGrpUnSel; SubNr:MAuswahl; Checked:False),
              (Cap:'Auswahl ~wiederholen'; Hot:'Alt+W'; Key:Taste_Alt_W; Nr:PGrpRepeat; SubNr:MAuswahl; Checked:False)
             );

  { Sortier-Typen: }
  SortName = 0;
  SortExtens = 1;
  SortSize = 2;

  { Gre des Kopier-Puffers: }
  BlockSize = 49999;

Type
  SizeDateT = Array[0..Maxdateien]
              Of Bloed;              { Nimmt den Inhalt eines Verzeichnisses auf }

  ScreenSavType = Record
     x, y, Width, Height,            { Nimmt Daten fr gesicherten }
     RestX: Word;                    { Bildschirmausschnitt auf }
  End;

Var
  { Wichtige Variablen fr Men: }
  AktUnterMenu: Byte;                { Welches Untermen ist aktiv? }
  UnterMenuAktiv: Boolean;           { Untermen an/aus }
  AktKommando: Integer;              { Das aktuelle Men-Kommando }
  { Allmglicher anderer Kram }
  Uhr:UhrXYVFHF;
  Rechts:Boolean;                    { Rechtes Fenster? Nein? Dann eben linkes... }
  OldPath,OtherPath:String;          { Pfad des inaktiven Fensters }
  AnzDateien:Array[0..1] Of Word;    { Wir brauchen ja immer alles zweimal! }
  Dateien:Array[0..1] Of ^SizeDateT; { s.o. }
  ListenBegin, SchirmPos:Array[0..1]
               Of Word;              { Fr Fenster-Darstellung }
  Suchen: Array[0..1] Of String;     { Such-String }
  Sortieren: Array[0..1] Of Byte;    { Wonach sortiert werden soll }
  DateiFilter: Array[0..1] Of
               String[12];           { Datei-Filter }
  GroupMask: String[12];
  Block: Array[0..BlockSize] Of Byte;{ Kopier-Puffer }
  dummy: Integer;                    { Kann man immer brauchen... }
  HardCopy: Array[0..3999] Of Byte;  { Um den Bildschirm zu sichern }
  AltX,AltY: Byte;                   { dito }
  Auswahl_Elemente: Array[0..9] Of
                    String[30];      { Fr Auswahlfelder }
  OverWriteAll: Boolean;             { Alle Dateien berschrieben? }
  ScreenSav: Array[0..3999] Of Byte; { Zum Sichern von Bildschirmteilen }
  ScreenSavData: ScreenSavType;      { dito }

Procedure ZeLine(x,y,height:Word); Assembler;
Asm
   push es
   les di,TBuf
   mov ax,80
   mul y
   add ax,x
   shl ax,1
   add di,ax
   mov cx,height
   dec cx
   mov al,209
   mov es:[di],al
   inc di
   mov al,attrib
   mov es:[di],al
   mov al,179
   mov ah,attrib
@Looping:
   add di,159
   mov es:[di],al
   inc di
   mov es:[di],ah
   dec cx
   jne @Looping
   mov al,207
   add di,159
   mov es:[di],al
   inc di
   mov es:[di],ah
   pop es
End;

Procedure AttrLine(x,y,Length: Word; Col: Byte);
Var
   i: Word;
Begin
     For i:=x To x+Length-1 Do Begin
         PutBackColor(i,y,Col);
     End;
End;

Procedure XChange(Var Var1, Var2: Word);
var
   Dummy: Word;
Begin
     Dummy:=Var1;
     Var1:=Var2;
     Var2:=Dummy;
End;

Procedure SaveScreen(x1,y1,x2,y2: Word);
Var
   Dtx, Dty, Rest: Word;
Begin
     With ScreenSavData Do Begin
          If x1 > x2 then XChange(x1,x2);
          If y1 > y2 then XChange(y1,y2);
          If x1 > 79 Then x1:=79;
          If y1 > 24 Then y1:=24;
          If x2 > 79 Then x2:=79;
          If y2 > 24 Then y2:=24;
          x:=x1;
          y:=y1;
          Width:=x2-x1+1;
          Height:=y2-y1+1;
          RestX:=(80-Width)*2;
          If (Width = 0) Or (Height = 0) Then Exit;
          Dtx:=Width;
          Dty:=Height;
          Rest:=RestX;
     End;
Asm
   push  es
   push  ds
   mov   di,OFFSET ScreenSav
   mov   ax,ds
   mov   es,ax
   lds   si,TBuf
   mov   ax,80
   mul   y1
   add   ax,x1
   shl   ax,1
   add   si,ax
@Y_Loop:
   mov   cx,Dtx
   shl   cx,1
   rep   movsb
   add   si,rest
   dec   Dty
   jne   @Y_Loop
   pop   ds
   pop   es
End;
End;

Procedure RestoreScreen; Assembler;
Asm
   push  es
   push  ds
   les   di,TBuf
   mov   ax,80
   mov   bx,Word Ptr ScreenSavData.y
   mul   bx
   add   ax,Word Ptr ScreenSavData.x
   shl   ax,1
   add   di,ax
   mov   si,OFFSET ScreenSav
   mov   bx,Word Ptr ScreensavData.Height
@Y_Loop:
   mov   cx,Word Ptr ScreensavData.Width
   shl   cx,1
   rep   movsb
   add   di,Word Ptr ScreensavData.RestX
   dec   bx
   jne   @Y_Loop
   pop   ds
   pop   es
End;

Procedure CursorOnOff(OnOff: Boolean); Assembler;
Asm
     XOR Ax,Ax                                            {Ax auf 0.}
     MOV Al,OnOff                      {Cursor an- oder ausschalten?}
     Or  Al,Al
     JA  @1                                   {Wenn on dann nach @1.}
     SUB Ax,Ax                                            {Ax auf 0.}
     MOV Ah,01h                                       {Funktion 01h.}
     MOV Ch,20h                              {Ch auf gleichen Wert..}
     MOV Cl,20h                                           {..wie Cl.}
     INT 10h                                    {Bios-Interrupt 10h.}
     JMP @3                                      {ans Ende springen.}
@1:                                     {Routine Cursor einschalten.}
     Xor Ax,Ax                                            {Ax auf 0.}
     Mov Ah,0Fh                                       {Funktion 0Fh.}
     Int 10h                                    {Bios-Interrupt 10h.}
     Cmp Ah,7                                    {Wenn Ergebnis = 7.}
     JE  @2                          {Dann liegt Farbbildschirm vor.}
     XOR Al,Al                                            {Al auf 0.}
     MOV AH,01h                                       {Funktion 01h.}
     MOV CX,0607h                            {Cursorgre festlegen.}
     INT 10h                                    {Bios-Interrupt 10h.}
     JMP @3                                      {ans Ende springen.}
@2:                                 {Routine fr den Farbbildschirm.}
     SUB Al,Al                                            {Al auf 0.}
     MOV Ah,01h                                       {Funktion 01h.}
     MOV CX,0C0Dh                            {Cursorgre festlegen.}
     INT 10h                                    {Bios-Interrupt 10h.}
@3:
End;

Function UpCaseDeu(Zeichen: Char): Char;
Begin
     Case Zeichen Of
          'a'..'z': Zeichen:=UpCase(Zeichen);
          '': Zeichen:='';
          '': Zeichen:='';
          '': Zeichen:='';
     End;
     UpCaseDeu:=Zeichen;
End;

Function Stri(Zahl:Longint):String;
Var
   Tmp:String;
Begin
     Str(Zahl,Tmp);
     Stri:=Tmp;
End;

Procedure Color(vf,hf:Byte);
Begin
     Textcolor(vf);
     TextBackGround(hf);
End;

Function Formatted(Zahl: Longint): String;
Var
   s: String;
   i: Byte;
   counter: Byte;
Begin
     Str(Zahl,s);
     Counter:=0;
     For i:=Length(s) DownTo 1 Do Begin
         Inc(Counter);
         If Counter >= 3 Then Begin
            If i > 1 Then Begin
               Insert('.',s,i);
               Counter:=0;
            End;
         End;
     End;
     formatted:=s;
End;

Function GetCentered(wert1,wert2,breite: byte): Integer;
Begin
     GetCentered:=(Wert1+(((Wert2-Wert1)-Breite) Div 2));
End;

Function Cut(Txt: String; MaxLength: Byte): String;
Var
   Len: Byte;
Begin
     Len:=Length(Txt);
     Cut:=Txt;
     If (Len < 4) Or (MaxLength < 4) Then Exit;
     If Len > MaxLength Then Begin
        Cut:='...'+Copy(Txt,Len-(MaxLength-5),MaxLength-4);
     End;
End;

Procedure Fenster(x1,y1,x2,y2: Word; HeadLine: String; Shadow: Boolean);
Var
   i: Integer;
Begin
     BoxDouble(x1,y1,x2,y2);
     Bar(x1+1,y1+1,x2-1,y2-1,' ');
     If Shadow Then Begin
        For i:=x1+2 To x2+2 Do MakeShadow(i,y2+1);
        For i:=y1+1 To y2+1 Do Begin
            makeShadow(x2+1,i);
            makeShadow(x2+2,i);
        End;
     End;
     PutString(GetCentered(x1,x2,Length(Headline)),y1,HeadLine);
End;

Function EingabeZeile(x,y,width: Word; Vorgabe: String): String;
Var
   Tmp: String;
   Tmp2: String;
   Ch: Char;
   Cursor: Byte;
Begin
     EingabeZeile:='';
     Tmp:=Vorgabe;
     CursorOnOff(True);
     FillChar(Tmp2,Width+1,'');
     Tmp2[0]:=Chr(Width);
     Cursor:=Length(Tmp);;
     Repeat
           SetColors(White,Black);
           PutString(x,y,Tmp2);
           PutString(x,y,Tmp);
           ShowTBuf;
           GotoXY(x+1+Cursor,y+1);
           Ch:=ReadKey;
           If Ch = #0 Then Begin
              Ch:=ReadKey;
              Case Ch Of
                   Taste_PfeilLinks: Begin
                       If Cursor > 0 Then Dec(Cursor);
                   End;
                   Taste_PfeilRechts:Begin
                       If Cursor < Length(Tmp) Then Inc(Cursor);
                   End;
                   Taste_Pos1: Cursor := 0;
                   Taste_Ende: Cursor := Length(Tmp);
                   #83: Begin
                        If Cursor < Length(Tmp) Then Begin
                           Delete(Tmp,Cursor+1,1);
                        End;
                   End;
              End;
           End Else Begin
              Case Ch Of
                  Taste_Loeschen: Begin
                      If Cursor > 0 Then Begin
                         Delete(Tmp,Cursor,1);
                         Dec(Cursor);
                      End;
                  End;
                  #13: Begin
                       EingabeZeile:=Tmp;
                       CursorOnOff(False);
                       Exit;
                  End;
                  #27: Begin
                       EingabeZeile:='';
                       CursorOnOff(False);
                       Exit;
                  End Else Begin
                       If Length(Tmp) < Width-1 Then Begin
                          Insert(Ch,Tmp,Cursor+1);
                          Inc(Cursor);
                       End;
                  End;
              End;
           End;
     Until False;
End;

Function AuswahlFeld(x,y,abstand,Elemente,VF,HF,Balken: Byte): Integer;
Var
   Akt_Element: Byte;
   i,i2: Byte;
   Akt_x: Byte;
   Ch: Char;
Begin
     Akt_Element:=0;
     Repeat
           Akt_X:=X;
           For i:=0 To Elemente-1 Do Begin
               SetColors(VF,HF);
               PutString(Akt_x,y,Auswahl_Elemente[i]);
               SetColors(VF,Balken);
               If Akt_Element = i Then AttrLine(Akt_x,y,Length(Auswahl_Elemente[i]),Balken);
               Inc(Akt_x,Abstand+Length(Auswahl_Elemente[i]));
           End;
           ShowTBuf;
           Ch:=ReadKey;
           If Ch = #0 Then Begin
               Ch:=ReadKey;
               Case Ch Of
                    Taste_PfeilLinks: If Akt_Element > 0 Then Dec(Akt_Element) Else Akt_Element:=Elemente-1;
                    Taste_PfeilRechts: If Akt_Element < Elemente-1 Then Inc(Akt_Element) Else Akt_Element:=0;
                    Taste_Pos1: Akt_Element:=0;
                    Taste_Ende: Akt_Element:=Elemente-1;
               End;
           End Else Begin
               Case Ch Of
                    #13: Begin
                              AusWahlFeld:=Akt_Element;
                              Exit;
                         End;
                    #27: Begin
                              AusWahlFeld:=-1;
                              Exit;
                         End;
               End;
           End;
     Until (Ch = #13) Or (Ch = #27);
End;

Procedure Fehlermeldung(Fehler: String);
Var
   StartX,EndeX: Byte;
Begin
     If Fehler[0] > Chr(72) Then Fehler[0]:=Chr(72);
     StartX:=GetCentered(0,79,Length(Fehler)+4);
     EndeX:=StartX+Length(Fehler)+4;
     SetColors(White,Red);
     SaveScreen(StartX,10,EndeX+2,17);
     Fenster(StartX,10,EndeX,15,' Fehler: ',true);
     PutString(StartX+2,11,Fehler);
     ShowTBuf;
     Auswahl_Elemente[0]:=' OK ';
     Dummy:=AuswahlFeld(38,13,0,1,White,Red,Black);
     RestoreScreen;
     ShowTBuf;
End;

Procedure ChDirSafe(Path: String);
Var
   FehlerMeldung: String;
   Ok: Boolean;
Begin
     dummy:=IOResult; { IOResult zurcksetzen (kann sonst Fehler liefern, obwohl alles richtig war }
     Ok:=False;
     Repeat
           ChDir(Path);
           If IOResult <> 0 Then Begin
              If Length(Path) > 15 Then Path[0]:=Chr(15);
              FehlerMeldung:='Pfad: '+Path+' nicht gefunden!';
              SetColors(White,Red);
              Fenster(15,10,55,14,' Fehler: ',True);
              PutString(17,11,FehlerMeldung);
              PutString(17,12,'Geben Sie einen neuen Pfad ein:');
              Repeat
                    Path:=EingabeZeile(17,13,37,Path);
              Until Path <> '';
           End Else Ok:=True;
     Until Ok;
End;

Procedure Init_Vars;
Var
  i:Integer;
Begin
     GroupMask:='*.*';
     AltX:=WhereX;
     AltY:=WhereY;
     ScrToBuf(@HardCopy);
     Rechts:=False;
     CursorOnOff(False);
     For i:=0 To 1 Do Begin
         New(Dateien[i]);
         ListenBegin[i]:=0;
         SchirmPos[i]:=0;
         Sortieren[i]:=SortName;
         Suchen[i]:='';
         DateiFilter[i]:='*.*';
     End;
     GetDir(0,OtherPath);
     OtherPath:=OtherPath;
     Uhr.PositionX:=UhrX;
     Uhr.PositionY:=UhrY;
     Uhr.FarbeVordergrund:=UhrVF;
     Uhr.FarbeHintergrund:=UhrHF;
End;

Procedure Lade_Dateien(re:Byte);
Var
   Counter: Word;
   TmpDatei: SearchRec;
   F: File;
   FuckYou: DateTime;

Procedure SortiereVerz;
Var
   dummy: Bloed;
   sortiertOK: boolean;
   a: word;
Begin
     If AnzDateien[Byte(re)] <= 1 Then Exit;
     Repeat
           sortiertOK:=true;
           For a:=0 to AnzDateien[Byte(re)]-2 Do Begin
               If (Dateien[re]^[a+1].Attr And Directory) <> 0 Then Begin
                  If (Dateien[re]^[a].Attr And Directory) = 0 Then Begin
                     Dummy:=Dateien[re]^[a+1];
                     Dateien[re]^[a+1]:=Dateien[re]^[a];
                     Dateien[re]^[a]:=Dummy;
                     SortiertOK:=False;
                  End Else If (Dateien[re]^[a].Name > Dateien[re]^[a+1].Name) Then Begin
                     Dummy:=Dateien[re]^[a+1];
                     Dateien[re]^[a+1]:=Dateien[re]^[a];
                     Dateien[re]^[a]:=Dummy;
                     SortiertOK:=False;
                  End;
               End;
           End;
     Until sortiertOK = true;
End;

Procedure QSortName(l,r: Integer);
Var
   i,j: Integer;
   x: Bloed;
   Dummy: Bloed;
Begin
     i := l;
     j := r;
     x := Dateien[Byte(re)]^[(l+r) Shr 1];
     Repeat
           While Dateien[Byte(re)]^[i].Name+Dateien[Byte(re)]^[i].Extens < x.Name+x.Extens Do Inc(i);
           While Dateien[Byte(re)]^[j].Name+Dateien[Byte(re)]^[j].Extens > x.Name+x.Extens Do Dec(j);
           If i <= j Then Begin
              Dummy:=Dateien[Byte(re)]^[i];
              Dateien[Byte(re)]^[i]:=Dateien[Byte(re)]^[j];
              Dateien[Byte(re)]^[j]:=Dummy;
              Inc(i);
              Dec(j);
           End;
     Until i > j;
     If l < j Then QSortName(l,j);
     If i < r Then QSortName(i,r);
End;

Procedure QSortExtens(l,r: Integer);
Var
   i,j: Integer;
   x: Bloed;
   Dummy: Bloed;
Begin
     i := l;
     j := r;
     x := Dateien[Byte(re)]^[(l+r) Shr 1];
     Repeat
           While Dateien[Byte(re)]^[i].Extens+Dateien[Byte(re)]^[i].Name < x.Extens+x.Name Do Inc(i);
           While Dateien[Byte(re)]^[j].Extens+Dateien[Byte(re)]^[j].Name > x.Extens+x.Name Do Dec(j);
           If i <= j Then Begin
              Dummy:=Dateien[Byte(re)]^[i];
              Dateien[Byte(re)]^[i]:=Dateien[Byte(re)]^[j];
              Dateien[Byte(re)]^[j]:=Dummy;
              Inc(i);
              Dec(j);
           End;
     Until i > j;
     If l < j Then QSortExtens(l,j);
     If i < r Then QSortExtens(i,r);
End;

Procedure QSortSize(l,r: Integer);
Var
   i,j: Integer;
   x: Bloed;
   Dummy: Bloed;
Begin
     i := l;
     j := r;
     x := Dateien[Byte(re)]^[(l+r) Shr 1];
     Repeat
           While Dateien[Byte(re)]^[i].FSize > x.FSize Do Inc(i);
           While Dateien[Byte(re)]^[j].FSize < x.FSize Do Dec(j);
           If i <= j Then Begin
              Dummy:=Dateien[Byte(re)]^[i];
              Dateien[Byte(re)]^[i]:=Dateien[Byte(re)]^[j];
              Dateien[Byte(re)]^[j]:=Dummy;
              Inc(i);
              Dec(j);
           End;
     Until i > j;
     If l < j Then QSortSize(l,j);
     If i < r Then QSortSize(i,r);
End;

Begin
     dummy:=IOResult; { IOResult zurcksetzen (kann sonst Fehler liefern, obwohl alles richtig war }
     If re <> Byte(Rechts) Then Begin
        GetDir(0,OldPath);
        chdirsafe(OtherPath);
     End;
     Counter:=0;
     FindFirst('*.*', AnyFile, TmpDatei);
     While DosError = 0 Do Begin
           If (TmpDatei.Name <> '.') And ((TmpDatei.Attr And VolumeID) = 0) And ((TmpDatei.Attr And Directory) <> 0) Then Begin
              With Dateien[re]^[Counter] Do Begin
                   Name:=Copy(TmpDatei.Name,1,Pos('.',TmpDatei.Name)-1);
                   Extens:=Copy(TmpDatei.Name,Pos('.',TmpDatei.Name)+1,
                         Length(TmpDatei.Name)-Pos('.',TmpDatei.Name));
                   If (Pos('.',TmpDatei.Name)=0) Or
                      (TmpDatei.Name='..') Then Begin
                     Name:=TmpDatei.Name;
                     Extens:='';
                   End;
                   Attr:=TmpDatei.Attr;
                   Marker:=False;
                   FSize:=TmpDatei.Size;
                   UnpackTime(TmpDatei.Time,FuckYou);
                   Year:=FuckYou.Year;
                   Month:=FuckYou.Month;
                   Day:=FuckYou.Day;
              End;
              Inc(Counter);
              If Counter >= MaxDateien-1 Then Begin
                 FehlerMeldung('Speicher reicht nicht aus, um mehr als '+Stri(MaxDateien)+' Dateien anzuzeigen.');
                 Break;
              End;
           End;
           FindNext(TmpDatei);
     End;
     FindFirst(DateiFilter[re], AnyFile Xor Directory, TmpDatei);
     While DosError = 0 Do Begin
           If (TmpDatei.Name <> '.') And ((TmpDatei.Attr And VolumeID) = 0) Then Begin
             With Dateien[re]^[Counter] Do Begin
                  Name:=Copy(TmpDatei.Name,1,Pos('.',TmpDatei.Name)-1);
                  Extens:=Copy(TmpDatei.Name,Pos('.',TmpDatei.Name)+1,
                        Length(TmpDatei.Name)-Pos('.',TmpDatei.Name));
                  If (Pos('.',TmpDatei.Name)=0) Or
                     (TmpDatei.Name='..') Then Begin
                    Name:=TmpDatei.Name;
                    Extens:='';
                  End;
                  Attr:=TmpDatei.Attr;
                  Marker:=False;
                  FSize:=TmpDatei.Size;
                  UnpackTime(TmpDatei.Time,FuckYou);
                  Year:=FuckYou.Year;
                  Month:=FuckYou.Month;
                  Day:=FuckYou.Day;
             End;
             Inc(Counter);
             If Counter >= MaxDateien-1 Then Begin
                FehlerMeldung('Speicher reicht nicht aus, um mehr als '+Stri(MaxDateien)+' Dateien anzuzeigen.');
                Break;
             End;
           End;
           FindNext(TmpDatei);
     End;
     AnzDateien[re]:=Counter;
     Case Sortieren[re] Of
          SortName: QSortName(0,AnzDateien[re]-1);
          SortExtens: QSortExtens(0,AnzDateien[re]-1);
          SortSize: QSortSize(0,AnzDateien[re]-1);
     End;
     SortiereVerz;
     Suchen[re]:='';
     If re <> Byte(Rechts) Then Begin
        GetDir(0,OtherPath);
        chdirsafe(OldPath);
     End;
     If ListenBegin[re]+SchirmPos[re] > AnzDateien[re]-1 Then Begin
        ListenBegin[re]:=AnzDateien[re]-1;
        SchirmPos[re]:=0;
     End;
End;

Function FreeString(Zeichen:Char;Txt:String):String;
Var
   i:Integer;
   Tmp:String;
Begin
     Tmp:='';
     For i:=1 to Length(Txt) Do Begin
       If (Txt[i] <> Zeichen) Then Tmp:=Tmp+Txt[i];
     End;
     FreeString:=Tmp;
End;

Procedure ProzentBalken(x,y,width: byte; gesamt, teil: longint);
Var
   prozent: integer;
   breite: byte;
   MaleString: String;
Begin
     If Gesamt = 0 Then Gesamt:=1;
     prozent:=Round(Teil / Gesamt * 100);
     Breite:=Width*Prozent Div 100;
     FillChar(MaleString,Width,'');
     FillChar(MaleString,Breite,'');
     MaleString[0]:=Chr(Width-1);
     PutString(x,y,MaleString);
End;

Function MakeName(Name,Extens: String): String;
Var
   Tmp: String[12];
Begin
     Tmp:=Name;
     If Extens > '' Then Tmp:=Tmp+'.'+Extens;
     MakeName:=Tmp;
End;

Function SetFileAttr(Datei: String; Attr: Byte): Boolean;
Var
   f: File;
Begin
     Dummy:=IOResult;
     Assign(f,Datei);
     SetFAttr(f,Attr);
     If IOResult <> 0 Then Begin
        FehlerMeldung('Zugriff verweigert auf '+Datei+'.');
        SetFileAttr:=False;
        Exit;
     End;
     SetFileAttr:=True;
End;

Procedure CountSize(Var Size, AnzDat, AnzVer: LongInt);
Var
   i: Word;
   r: Byte;
   Markierte: Boolean;
   Tmp: SearchRec;

Procedure CountSizeDir(DirName: String; Var Size, AnzDat, AnzVer: Longint);
Var
   Tmp: SearchRec;
Begin
     ChDirSafe(DirName);
     dummy:=IOResult;
     FindFirst('*.*',AnyFile,Tmp);
     While DosError = 0 Do Begin
           If (Tmp.Name <> '..') And (Tmp.Name <> '.') And ((Tmp.Attr And Directory) <> 0) Then Begin
              CountSizeDir(Tmp.Name,Size,AnzDat,AnzVer);
              Inc(AnzVer);
           End;
           FindNext(Tmp);
     End;
     FindFirst(DateiFilter[r],Anyfile Xor Directory,Tmp);
     While DosError = 0 Do Begin
           If ((Tmp.Attr And VolumeID) = 0) Then Begin
              Inc(Size,Tmp.Size);
              Inc(AnzDat);
           End;
           FindNext(Tmp);
     End;
     ChDirSafe('..');
End;

Begin
     Size:=0;
     AnzDat:=0;
     AnzVer:=0;
     r:=Byte(Rechts);
     Markierte:=False;
     For i:=0 To AnzDateien[r]-1 Do If Dateien[r]^[i].Marker Then Markierte:=True;
     If Markierte Then Begin
        For i:=0 To AnzDateien[r]-1 Do If Dateien[r]^[i].Marker Then Begin
            If ((Dateien[r]^[i].Attr And Directory) <> 0) Then Begin
               If Dateien[r]^[i].Extens > '' Then
                  CountSizeDir(Dateien[r]^[i].Name+'.'+Dateien[r]^[i].Extens,Size,AnzDat,AnzVer)
               Else
                  CountSizeDir(Dateien[r]^[i].Name,Size,AnzDat,AnzVer);
               Inc(AnzVer);
            End Else Begin
               Inc(Size,Dateien[r]^[i].FSize);
               Inc(AnzDat);
            End;
        End;
     End Else Begin
        i:=ListenBegin[r]+SchirmPos[r];
        If ((Dateien[r]^[i].Attr And Directory) <> 0) Then Begin
           CountSizeDir(MakeName(Dateien[r]^[i].Name,Dateien[r]^[i].Extens),Size,AnzDat,AnzVer);
           Inc(AnzVer);
        End Else Begin
           Size:=Dateien[r]^[i].FSize;
           AnzDat:=1;
        End;
     End;
End;

Function Loeschen(Datei: String): Boolean;
Var
   f: File;
Begin
     Loeschen:=True;
     Assign(f,Datei);
     Erase(f);
     If IOResult <> 0 Then Begin
        SetFileAttr(Datei,Archive);
        Dummy:=IOResult;
        Erase(f);
     End;
     If IOResult <> 0 Then Loeschen:=False;
End;

Procedure LoescheAlles;
Const
   Width = 50;
Var
   AktPath: String;
   i: Word;
   r: Byte;
   Mark,Verz: Boolean;
   Result: Char;
   Killed: Boolean;
   AnzDat, AnzVer, Bytes: Longint;
   KilledFiles: Longint;
   KilledPercent: Real;
   Blocks: Byte;
   PercentBar: String;

Procedure ShowKilling(Name: String);
Var
   Tmp: String;
Begin
     KilledPercent:=(KilledFiles * 100 / AnzDat);
     Blocks:=Round(KilledPercent) * Width Div 100;
     FillChar(PercentBar[1],Blocks,'');
     Tmp[0]:=Chr(51);
     FillChar(Tmp[1],51,' ');
     PutString(15,10,Tmp);
     PutString(15,10,Cut(AktPath+'\'+Name,51));
     PutString(15,11,PercentBar);
     ShowTBuf;
End;

Procedure LoescheVerz(Verz: String; Var Killed: Boolean);
Var
   Tmp: SearchRec;
Begin
     Dummy:=IOResult;
     ChDir(Verz);
     GetDir(0,AktPath);
     If IOResult <> 0 Then Begin
        Killed:=False;
        Exit;
     End;
     FindFirst('*.*',Anyfile,Tmp);
     While DosError = 0 Do Begin
           If (Tmp.Name <> '.') And (Tmp.Name <> '..') And ((Tmp.Attr And Directory) <> 0) Then Begin
              LoescheVerz(Tmp.Name,Killed);
              If Killed <> True Then Begin
                 Exit;
              End;
           End;
           FindNext(Tmp);
     End;
     FindFirst(DateiFilter[r],AnyFile Xor Directory,Tmp);
     While DosError = 0 Do Begin
           ShowKilling(Tmp.Name);
           Killed:=Loeschen(Tmp.Name);
           If Killed <> True Then Begin
              FehlerMeldung('Fehler beim Lschen von '+Tmp.Name+'.');
              Exit;
           End;
           Inc(KilledFiles);
           FindNext(Tmp);
     End;
     ChDir('..');
     GetDir(0,AktPath);
     Rmdir(Verz);
     Killed:=True;
End;

Begin
     GetDir(0,AktPath);
     FillChar(PercentBar[1],Width,'');
     PercentBar[0]:=Chr(Width);
     KilledFiles:=0;
     CountSize(Bytes,AnzDat,AnzVer);
     SaveScreen(5,6,77,19);
     SetColors(White,Red);
     Fenster(5,6,75,18,' Besttigung zum Lschen: ',True);
     PutString(7,8, 'Gelscht werden:');
     PutString(7,10, 'Verzeichnisse:');
     PutString(7,11,'      Dateien:');
     PutString(7,12,'        Bytes:');
     SetColors(Yellow,Red);
     PutString(22,10,Formatted(AnzVer));
     PutString(22,11,Formatted(AnzDat));
     PutString(22,12,Formatted(Bytes));
     SetColors(White,Red);
     PutString(7,14,'Wollen Sie diese Daten wirklich lschen?');
     ShowTBuf;
     AusWahl_Elemente[0]:=' Nein ';
     AusWahl_Elemente[1]:='  Ja  ';
     Dummy:=AuswahlFeld(32,16,3,2,White,Red,Black);
     RestoreScreen;
     ShowTBuf;

     SetColors(SchriftNormal,FensterNormal);
     Fenster(13,9,67,12,' Lsche: ',True);

     If Dummy <> 1 Then Exit;
     r:=Byte(Rechts);
     Verz:=False;
     Mark:=False;
     For i:=0 To AnzDateien[r]-1 Do With Dateien[r]^[i] Do Begin
         If Marker Then Begin
            Mark:=True;
            If (Attr And Directory) <> 0 Then Verz:=True;
         End;
     End;
     If Mark Then Begin
        For i:=0 To AnzDateien[r]-1 Do With Dateien[r]^[i] Do Begin
           If Marker And (Name <> '..') Then Begin
              If ((Attr And Directory) <> 0) Then Begin
                 Killed:=True;
                 LoescheVerz(MakeName(Name,Extens),Killed);
                 If (Not Killed) Then Begin
                    FehlerMeldung('Fehler beim Lschen von '+MakeName(Name,Extens)+'.');
                    Exit;
                 End;
              End Else Begin
                 ShowKilling(MakeName(Name,Extens));
                 Killed:=Loeschen(MakeName(Name,Extens));
                 If (Not Killed) Then Begin
                    FehlerMeldung('Fehler beim Lschen von '+MakeName(Name,Extens)+'.');
                    Exit;
                 End;
                 Inc(KilledFiles);
              End;
           End;
        End;
     End Else With Dateien[r]^[ListenBegin[r]+SchirmPos[r]] Do Begin
         If (Attr And Directory) <> 0 Then Begin
            If Name = '..' Then Exit;
            LoescheVerz(MakeName(Name,Extens),Killed);
            If Killed <> True Then Begin
               FehlerMeldung('Fehler beim Lschen von '+MakeName(Name,Extens)+'.');
            End;
         End Else Begin
            ShowKilling(MakeName(Name,Extens));
            Killed:=Loeschen(MakeName(Name,Extens));
            If Killed <> True Then FehlerMeldung('Fehler beim Lschen von '+MakeName(Name,Extens)+'.');
            Inc(KilledFiles);
         End;
     End;
     Lade_Dateien(0);
     Lade_Dateien(1);
End;

Function FileExists(FileName: String): Boolean;
Var
   F: file;
Begin
     Dummy:=IOResult;
     Assign(F, FileName);
     Reset(F);
     Close(F);
     FileExists := (IOResult = 0) And (FileName <> '');
End;

Function Kopieren(Quelle,Ziel: String; Gesamt,KopiertGesamt: LongInt; Versch: Boolean): LongInt;
Const
     x = 15;
     y = 10;
     width = 50;
     VF = White;
     HF = LightGray;
Var
   Q,Z: File;
   Gelesen: Word;
   QSize: LongInt;
   Kopiert: LongInt;
   InfoString: String;
   DelString: String;
   OverWrite: Boolean;
   Attr: Word;
Begin
     OverWrite:=False;
     If FileExists(Ziel) Then Begin
        If (Not OverWriteAll) Then Begin
           SetColors(White,Red);
           SaveScreen(10,16,72,23);
           Fenster(10,16,70,22,' Warnung: ',True);
           PutString(12,17,'Die Datei '+Cut(Ziel,48));
           PutString(12,18,'existiert schon im Zielverzeichnis. berschreiben?');
           ShowTBuf;
           AusWahl_Elemente[0]:='  Ja  ';
           AusWahl_Elemente[1]:=' Nein ';
           AusWahl_Elemente[2]:=' Alle ';
           Dummy:=AuswahlFeld(28,20,3,3,White,Red,Black);
           RestoreScreen;
           ShowTBuf;
           Case Dummy Of
                -1: Begin Kopieren:=-1; Exit; End;
                0: OverWrite:=True;
                1: Begin Kopieren:=0; Exit; End;
                2: OverWriteAll:=True;
           End;
        End Else OverWrite:=True;
     End;
     Kopieren:=-1;
     Kopiert:=0;
     dummy:=IOResult;
     Assign(Q,Quelle);
     Attr:=Archive;
     GetFAttr(Q,Attr);
     dummy:=IOResult;
     SetFAttr(Q,Archive);
     dummy:=IOResult;
     Reset(Q,1);
     If IOResult <> 0 Then Begin
        Exit;
     End;
     QSize:=FileSize(Q);
     dummy:=IOResult;
     Assign(Z,Ziel);
     SetFAttr(Z,Archive);
     Dummy:=IOResult;
     Rewrite(Z,1);
     If IOResult <> 0 Then Begin
        Close(Q);
        dummy:=IOResult;
        SetFAttr(Q,Attr);
        dummy:=IOResult;
        Exit;
     End;
     SetColors(SchriftNormal,FensterNormal);
     FillChar(DelString,Width+1,' ');
     DelString[0]:=Chr(Width);
     Repeat
           Dummy:=IOResult;
           BlockRead(Q,Block,BlockSize,Gelesen);
           If IOResult <> 0 Then Begin
              Close(Q);
              Close(Z);
              dummy:=IOResult;
              SetFAttr(Q,Attr);
              dummy:=IOResult;
              SetFAttr(Z,Attr);
              dummy:=IOResult;
              Exit;
           End;
           Dummy:=IOResult;
           BlockWrite(Z,Block,Gelesen);
           If IOResult <> 0 Then Begin
              Close(Q);
              Close(Z);
              dummy:=IOResult;
              SetFAttr(Q,Attr);
              dummy:=IOResult;
              SetFAttr(Z,Attr);
              dummy:=IOResult;
              Exit;
           End;
           If KeyPressed Then Begin
              If ReadKey = #27 Then Begin
                 Kopieren:=-1;
                 Close(Q);
                 dummy:=IOResult;
                 Close(Z);
                 dummy:=IOResult;
                 SetFAttr(Q,Attr);
                 dummy:=IOResult;
                 SetFAttr(Z,Attr);
                 dummy:=IOResult;
                 Exit;
              End;
           End;
           Inc(Kopiert,Gelesen);
           ProzentBalken(x,y,width,QSize,Kopiert);
           ProzentBalken(x,y+2,width,Gesamt,KopiertGesamt+Kopiert);
           InfoString:=Cut(Quelle,23)+' -> ';
           InfoString:=InfoString+Cut(Ziel,50-Length(InfoString));
           If Length(InfoString) > width-1 Then InfoString[0]:=Chr(width-1);
           PutString(x,y-1,DelString);
           PutString(x,y-1,InfoString);
           ShowTbuf;
     Until Gelesen < BlockSize;
     If IOResult <> 0 Then Begin
        Close(Q);
        Close(Z);
        dummy:=IOResult;
        SetFAttr(Q,Attr);
        dummy:=IOResult;
        SetFAttr(Z,Attr);
        dummy:=IOResult;
        Exit;
     End;
     Close(Q);
     Close(Z);
     dummy:=IOResult;
     SetFAttr(Q,Attr);
     dummy:=IOResult;
     SetFAttr(Z,Attr);
     dummy:=IOResult;
     Kopieren:=Kopiert;
     If Versch Then Loeschen(Quelle);
End;

Function MakePath(Path: String): String;
Begin
     Path:=FreeString(' ',Path);
     If Path[Length(Path)] <> '\' Then Path:=Path+'\';
     MakePath:=Path;
End;

Procedure KopiereAlles(Verschieben: Boolean);
Var
   r:Byte;
   i:Integer;
   Dat:String;
   IsMark:Boolean;
   ZielVerz: String;
   Gesamt,Kopiert: LongInt;
   Tmp: SearchRec;
   Result: Longint;
   action: String;
   AnzDat, AnzVer: Longint;

Procedure KopierVerz(ZielVerz,Verz:String; Var Kopiert: Longint);
Var
   Tmp: SearchRec;
Begin
     dummy:=IOResult; { IOResult zurcksetzen (kann sonst Fehler liefern, obwohl alles richtig war }
     MkDir(ZielVerz+Verz);
     FindFirst(verz+'\'+'*.*',AnyFile,Tmp);
     While DosError = 0 Do Begin
           If (Tmp.Name <> '..') And (Tmp.Name <> '.') And ((Tmp.Attr And Directory) <> 0) Then
              KopierVerz(ZielVerz,Verz+'\'+Tmp.Name,Kopiert);
           If Kopiert < 0 Then Begin
              Exit;
           End;
           FindNext(Tmp);
     End;
     Result:=0;
     FindFirst(verz+'\'+DateiFilter[r],Anyfile Xor Directory,Tmp);
     While DosError = 0 Do Begin
           If ((Tmp.Attr And VolumeID) = 0) Then
              Result:=Kopieren(verz+'\'+Tmp.Name,ZielVerz+Verz+'\'+Tmp.Name,Gesamt,Kopiert,Verschieben);
           If Result > -1 Then Begin
             Inc(Kopiert,Result);
             FindNext(Tmp);
           End Else Begin
             FehlerMeldung('Fehler beim Kopieren von '+verz+'\'+Tmp.Name+'.');
             Kopiert:=Result;
             Exit;
           End;
     End;
     If Verschieben Then Begin
        RmDir(verz);
        Dummy:=IOResult;
     End;
End;

Begin
     OverWriteAll:=False;
     IsMark:=False;
     r:=Byte(Rechts);
     For i:=0 To AnzDateien[r]-1 Do Begin
         If Dateien[r]^[i].Marker Then Begin
            If Dateien[r]^[i].Name = '..' Then Exit;
            IsMark:=True;
            Break;
         End;
     End;
     If (Not IsMark) Then Begin
        If Dateien[r]^[ListenBegin[r]+SchirmPos[r]].Name = '..' Then Exit;
     End;
     If Verschieben Then action := 'Verschieben' Else action := 'Kopieren';
     Kopiert:=0;
     CountSize(Gesamt,AnzDat,AnzVer);
     SaveScreen(5,7,77,16);
     SetColors(SchriftNormal,FensterNormal);
     Fenster(5,7,75,15,' '+action+': ',True);
     PutString(7,9, 'Verzeichnisse:');
     PutString(7,10,'      Dateien:');
     PutString(7,11,'        Bytes:');
     SetColors(Yellow,FensterNormal);
     PutString(22,9,Formatted(AnzVer));
     PutString(22,10,Formatted(AnzDat));
     PutString(22,11,Formatted(Gesamt));
     SetColors(SchriftNormal,FensterNormal);
     PutString(7,13,action+' nach: ');
     ZielVerz:=EingabeZeile(7,14,67,OtherPath);
     RestoreScreen;
     ShowTBuf;

     If ZielVerz = '' Then Exit;

     SetColors(SchriftNormal,FensterNormal);
     Fenster(13,8,65,13,' '+action+': ',True);
     PutString(15,11,'Gesamt:');
     ProzentBalken(15,10,50,100,0);
     ProzentBalken(15,12,50,100,0);
     ZielVerz:=MakePath(ZielVerz);
     If IsMark Then Begin
       For i:=0 To AnzDateien[r]-1 Do Begin
         If Dateien[r]^[i].Marker Then Begin
           ProzentBalken(15,10,50,100,0);
           ShowTBuf;
           If (Dateien[r]^[i].Attr And Directory) <> 0 Then Begin
              KopierVerz(ZielVerz,
                         MakeName(Dateien[r]^[i].Name,Dateien[r]^[i].Extens),Kopiert);
              If Kopiert < 0 Then Exit;
           End Else Begin
               Dat:=MakeName(Dateien[r]^[i].Name,Dateien[r]^[i].Extens);
               Result:=Kopieren(Dat,ZielVerz+Dat,Gesamt,Kopiert,Verschieben);
               If Result < 0 Then Begin
                  FehlerMeldung('Fehler beim Kopieren von '+Dat+'.');
                  Exit;
               End;
               Inc(Kopiert,Result);
           End;
         End;
         ProzentBalken(15,12,50,Gesamt,Kopiert);
       End;
     End Else Begin
       i:=ListenBegin[r]+SchirmPos[r];
       If (Dateien[r]^[i].Attr And Directory) <> 0 Then KopierVerz(ZielVerz,
              MakeName(Dateien[r]^[i].Name,Dateien[r]^[i].Extens),Kopiert)
       Else Begin
         i:=ListenBegin[r]+SchirmPos[r];
         Dat:=MakeName(Dateien[r]^[i].Name,Dateien[r]^[i].Extens);
         Result:=Kopieren(Dat,ZielVerz+Dat,Gesamt,Kopiert,Verschieben);
         If result < 0 Then Begin
            FehlerMeldung('Fehler beim Kopieren von '+Dat+'.');
            Exit;
         End;
         ProzentBalken(15,12,50,100,100);
       End;
     End;
     Lade_Dateien(r);
     Lade_Dateien(Byte(Not Rechts));
End;

Procedure ZeigUhr(x,y:Integer;vf,hf:Byte);
Var
   Tmp:String;
   Hour, Minute, Second, Sec100: Word;
Begin
     Tmp:='';
     SetColors(vf,hf);
     GetTime(Hour, Minute, Second, Sec100);
     Tmp:=Stri(Hour)+':';
     If Minute < 10 Then Tmp:=Tmp+'0'+Stri(Minute)+':'
     Else Tmp:=Tmp+Stri(Minute)+':';
     If Second < 10 Then Tmp:=Tmp+'0'+Stri(Second)
     Else Tmp:=Tmp+Stri(Second);
     If Hour < 10 Then PutString(x+1,y,Tmp)
     Else PutString(x,y,Tmp);
End;

Procedure DrawWindow(r: Byte);
Var
   i:Integer;
   Time:Longint;
   Dummy:DateTime;
   Tmp: String;
   X: Byte;
   Path: String;
Begin
    x:=r*40;
    SetColors(Vordergrund,Hintergrund);
    BoxDouble(x,DateiStart-2,x+39,MaxDateienScreen+DateiStart);
    ZeLine(x+13,DateiStart-2,MaxDateienScreen+2);
    ZeLine(x+23,DateiStart-2,MaxDateienScreen+2);
    ZeLine(x+32,DateiStart-2,MaxDateienScreen+2);

    If DateiFilter[r] <> '*.*' Then PutChar(r*40+1,0,'F');

    If r = Byte(Rechts) Then GetDir(0,Path) Else Path:=OtherPath;
    Path:=Cut(Path,35);
    PutString(r*40+3,0,Path);

    SetColors(Ueberschrift,Hintergrund);
    PutString(x+1,DateiStart-1,'Dateinamen: ');
    PutString(x+14,DateiStart-1,'Gre:   ');
    PutString(x+24,DateiStart-1,'Datum:  ');
    PutString(x+33,DateiStart-1,'Attr.:');


    For i:=0 To MaxDateienScreen-1 Do Begin
      If i+ListenBegin[r] = AnzDateien[r] Then Break;
      If Dateien[r]^[ListenBegin[r]+i].Marker Then
         SetColors(Markiert,Hintergrund)
      Else
         SetColors(Vordergrund,Hintergrund);
      With Dateien[r]^[i+ListenBegin[r]] Do Begin
          If (Attr And Directory) = 0 Then Begin
             PutString(x+1,i+DateiStart,LCase(Name));
             PutString(x+13-Length(Extens),i+DateiStart,LCase(Extens));
          End Else Begin
             PutString(x+1,i+DateiStart,Name);
             PutString(x+13-Length(Extens),i+DateiStart,Extens);
          End;

          If (Attr And Directory) = 0 Then Begin
             Tmp:=Stri((FSize));
             PutString(x+23-Length(Tmp),i+DateiStart,Tmp);
          End Else Begin
             If Name = '..' Then PutString(x+14,i+DateiStart,'>UP--DIR<') Else
                PutString(x+14,i+DateiStart,'>SUB-DIR<');
          End;
          If Day<10 Then Tmp:='0'+Stri(Day)+'.'
          Else Tmp:=Stri(Day)+'.';
          If Month<10 then Tmp:=Tmp+'0'+Stri(Month)+'.'
          Else Tmp:=Tmp+Stri(Month)+'.';
          Tmp:=Tmp+Copy(Stri(Year),3,2);
          PutString(x+24,i+DateiStart,Tmp);
          Tmp:='';
          If (Attr And Hidden) <> 0 Then Tmp:=Tmp+'H';
          If (Attr And ReadOnly) <> 0 Then Tmp:=Tmp+'R';
          If (Attr And SysFile) <> 0 Then Tmp:=Tmp+'S';
          If (Attr And Archive) <> 0 Then Tmp:=Tmp+'A';
          PutString(x+33,i+DateiStart,Tmp);
      End;
    End;
    If Byte(Rechts) = r Then Begin
       AttrLine(x+1,DateiStart+Schirmpos[r],38,Balken);
    End;
    If Suchen[r] <> '' Then Begin
       SetColors(Vordergrund,Hintergrund);
       PutString(x+3,MaxDateienScreen+DateiStart,' Suchen: ');
       PutString(x+12,MaxDateienScreen+DateiStart,Suchen[r]+' ');
    End;
End;

Procedure Paint_Desktop;
Var
   Meldung: String;
Begin
     SetColors(Vordergrund,Hintergrund);
     ClearTBuf(' ');
     DrawWindow(0);
     DrawWindow(1);
     Meldung:='BJ-Commander '+ver;
     SetColors(White,Blue);
     PutString(getcentered(0,79,Length(Meldung)),24,Meldung);
     PutString(0,24,'F10 fr Men');
     ZeigUhr(Uhr.PositionX,Uhr.PositionY,Uhr.FarbeVordergrund,Uhr.FarbeHintergrund);
End;

Procedure ChangeLW(Wo:Boolean);
Var
   f:File;
   ch:Char;
   i:Integer;
   Txt:String;
   Woais:Byte;
   MaxLaufs:Integer;
   Old,ActDrive: String;
   fl: Byte;
   Fls : array[1..2] of byte;
Begin
     port[$70]:=$10;
     fl:=port[$71];
     Fls[2] := Fl AND $0F;
     Fls[1] := Fl SHR 4;

     ch:=#0;

     GetDir(0,Old);
     If Wo <> Rechts Then chdirsafe(OtherPath);
     GetDir(0,ActDrive);
     chdirsafe(Old);

     Txt:='';
     MaxLaufs:=0;
     For i:=1 To 2 Do Begin
         If Fls[i] > 0 Then Begin
            Txt:=Txt+Chr(64+i);
            Inc(MaxLaufs);
         End;
     End;
     For i:=3 To 26 Do Begin
       If DiskSize(i) > 0 Then Begin
         Txt:=Txt+Chr(64+i);
         Inc(MaxLaufs);
       End;
     End;

     Woais:=1;
     For i:=1 To Length(Txt) Do Begin
         If Txt[i] = ActDrive[1] Then Woais:=i;
     End;

     Setcolors(SchriftNormal,FensterNormal);
     Fenster(15+Byte(Wo)*40,10,26+Byte(Wo)*40,12,'Laufwerk?',True);
     SetColors(SchriftNormal,FensterNormal);

     Repeat
           PutString(18+Byte(Wo)*40,11,Chr(24)+' '+Txt[Woais]+': '+Chr(25));
           Showtbuf;

           ch:=ReadKey;
           If Ch=#0 Then Begin
              ch:=Readkey;
              Case ch of
                   #72:If Woais > 1 Then dec(Woais);
                   #80:If Woais < MaxLaufs Then Inc(Woais);
              End;
           End;
     Until (ch=#13) Or (ch=#27);

     If (Ch=#13) And (Rechts=Wo) Then Begin
        chdirsafe(Txt[Woais]+':');
        Lade_Dateien(Byte(Rechts));
        ListenBegin[Byte(Rechts)]:=0;
        SchirmPos[Byte(Rechts)]:=0;
     End Else If (Ch=#13) And (Rechts<>Wo) Then Begin
        Rechts:=Not Rechts;
        GetDir(0,OtherPath);
        chdirsafe(Txt[Woais]+':');
        Lade_Dateien(Byte(Rechts));
        ListenBegin[Byte(Rechts)]:=0;
        SchirmPos[Byte(Rechts)]:=0;
        Rechts:=Not Rechts;
        OldPath:=OtherPath;
        GetDir(0,OtherPath);
        chdirsafe(OldPath);
     End;
End;

Procedure Filter(r: Byte);
Var
   f: String;
   Ok: Boolean;
Begin
     f:=DateiFilter[r];
     Repeat
       Paint_Desktop;
       SetColors(SchriftNormal,FensterNormal);
       Fenster(10+r*40,10,26+r*40,12,' Filter: ',True);
       f:=EingabeZeile(12+r*40,11,13,f);
       If f = '' Then Exit;
       If (Pos(':',f)>0) Or (Pos('\',f)>0) Then Begin
          FehlerMeldung('Laufwerks- und/oder Verzeichnis-Angaben sind nicht erlaubt.');
          Ok:=False;
       End Else Ok:=True;
     Until Ok;
     DateiFilter[r]:=f;
     Lade_Dateien(r);
     SchirmPos[r]:=0;
     ListenBegin[r]:=0;
End;

Procedure NoFilter(r: Byte);
Begin
     DateiFilter[r]:='*.*';
     Lade_Dateien(r);
     SchirmPos[r]:=0;
     ListenBegin[r]:=0;
End;

Procedure Umbenennen(Alt: String);
Var
   Neu: String;
   f: File;
   Ok: Boolean;
Begin
     Ok:=True;
     Neu:=Alt;
     If Alt = '..' Then Exit;
     Repeat
         Paint_Desktop;
         SetColors(SchriftNormal,FensterNormal);
         Fenster(25,10,55,13,' Umbennen: ',True);
         PutString(27,11,Alt+' umbennen in:');
         ShowTBuf;
         Neu:=EingabeZeile(27,12,27,Neu);
         If Neu = '' Then Exit;
         If (pos('\',Neu)>0) or (pos(':',Neu)>0) Then Begin
            FehlerMeldung('Laufwerks- und/oder Verzeichnis-Angaben sind nicht erlaubt.');
            Ok:=False;
         End;
     Until Ok;
     Dummy:=IOResult;
     Assign(f,Alt);
     Rename(f,Neu);
     If IOresult <> 0 Then
        FehlerMeldung('Fehler beim Umbenennen von '+Alt+' in '+Neu+'.');
     Lade_Dateien(0);
     Lade_Dateien(1);
End;

Procedure ScrollUp;
Begin
     If SchirmPos[Byte(Rechts)] > 0 Then
        Dec(SchirmPos[Byte(Rechts)])
     Else If (ListenBegin[Byte(Rechts)]>0) Then
          Dec(ListenBegin[Byte(Rechts)]);
End;

Procedure ScrollDown;
Begin
     If (SchirmPos[Byte(Rechts)] < MaxDateienScreen-1) And (SchirmPos[Byte(Rechts)]+1+
        ListenBegin[Byte(Rechts)] < AnzDateien[Byte(Rechts)]) Then
        inc(SchirmPos[Byte(Rechts)])
     Else If (SchirmPos[Byte(Rechts)] = MaxDateienScreen-1) And
             (ListenBegin[Byte(Rechts)]+MaxDateienScreen < AnzDateien[Byte(Rechts)]) Then
        Inc(ListenBegin[Byte(Rechts)]);
End;

Procedure Markieren;
Begin
     if Dateien[Byte(Rechts)]^[ListenBegin[Byte(Rechts)] +
        SchirmPos[Byte(Rechts)]].Name <> '..' Then Begin
        Dateien[Byte(Rechts)]^[ListenBegin[Byte(Rechts)] +
           SchirmPos[Byte(Rechts)]].Marker:=Not Dateien[Byte(Rechts)]^[ListenBegin[Byte(Rechts)] +
           SchirmPos[Byte(Rechts)]].Marker;
     End;
     ScrollDown;
End;

Procedure PageUp;
Var
   i: Integer;
Begin
     For i:=0 to MaxDateienScreen-2 Do ScrollUp;
End;

Procedure PageDown;
Var
   i: Integer;
Begin
     For i:=0 to MaxDateienScreen-2 Do ScrollDown;
End;

Procedure Pos1;
Begin
     SchirmPos[Byte(Rechts)]:=0;
     ListenBegin[Byte(Rechts)]:=0;
     Suchen[Byte(Rechts)]:='';
End;

Procedure Ende;
Begin
     If AnzDateien[Byte(Rechts)]>MaxDateienScreen-1 Then Begin
       SchirmPos[Byte(Rechts)]:=MaxDateienScreen-1;
       ListenBegin[Byte(Rechts)]:=AnzDateien[Byte(Rechts)]-MaxDateienScreen;
     End Else SchirmPos[Byte(Rechts)]:=AnzDateien[Byte(Rechts)]-1;
End;

Procedure PicView(Name,Extens: String);
Var
   Pic: SpriteTyp;
   Akt_Pic,Max_Pic: Byte;
   Result: Boolean;
   Anfang: LongInt;
   Laenge: Word;
   Ch: Char;
Begin
     VBuf:=Ptr($0a000,$0000);
     If MaxAvail < $FFFF Then Begin
        FehlerMeldung('Nicht gengend Speicher.');
        Exit;
     End;
     GetMem(VScreen,$FFFF);
     Asm
        mov ax,13h
        int 10h
     End;
     If Extens = 'BJF' Then Begin
        ClearVBuf(0);
        Load_Sprite(MakeName(Name,Extens),Pic,0);
        If Error = 0 Then Begin
           SetPal;
           PutSprite_Medium(0,0,Pic);
           ReadKey;
           FreeSprite(Pic);
        End;
     End Else If Extens = 'PCX' Then Begin
        ClearVBuf(0);
        Load_PCX_Sprite(MakeName(Name,Extens),Pic);
        If Error = 0 Then Begin
           SetPal;
           PutSprite_Medium(0,0,Pic);
           ReadKey;
           FreeSprite(Pic);
        End;
     End Else If Extens = 'LIB' Then Begin
        Akt_Pic:=0;
        Max_Pic:=GetFilePics(MakeName(Name,Extens))-1;
        Repeat
              ClearVBuf(0);
              Result:=GetFileInfo(MakeName(Name,Extens),Akt_Pic,Anfang,Laenge);
              If Result = True Then Begin
                 Load_Sprite(MakeName(Name,Extens),Pic,Anfang);
                 If Error = NoError Then Begin
                    SetPal;
                    PutSprite_Medium(0,0,Pic);
                    FreeSprite(Pic);
                 End;
              End;
              Ch:=ReadKey;
              If Ch = #0 Then Begin
                 Ch:=ReadKey;
                 Case Ch Of
                      Taste_PfeilLinks: If Akt_Pic > 0 Then Dec(Akt_Pic) Else Akt_Pic:=Max_Pic;
                      Taste_PfeilRechts: If Akt_Pic < Max_Pic Then Inc(Akt_Pic) Else Akt_Pic:=0;
                      Taste_Pos1: Akt_Pic:=0;
                      Taste_Ende: Akt_Pic:=Max_Pic;
                 End;
              End;
        Until Ch = #27;
     End Else If Extens = 'VID' Then Begin
        Repeat
             Video_Init(MakeName(Name,Extens));
             Video_Play(0,0);
             Video_Close;
        Until KeyPressed;
        Readkey;
     End;
     FreeMem(VScreen,$FFFF);
     TextMode(3);
     CursorOnOff(False);
     Paint_Desktop;
     ShowTBuf;
End;

Procedure ChangeDir;
Var
   N,E: String;
   r: Byte;
   AktPath: String;
   d: DirStr;
   nam: NameStr;
   ext: ExtStr;
   UpDir: Boolean;
   i: Word;
   AktDir: Word;
Begin
     r:=Byte(Rechts);
     GetDir(0,AktPath);
     If Dateien[r]^[ListenBegin[r]+SchirmPos[r]].Name = '..' Then UpDir:=True Else UpDir:=False;

     If (Dateien[r]^[ListenBegin[r]+SchirmPos[r]].Attr And Directory) <> 0 Then Begin
        If Dateien[r]^[ListenBegin[r]+SchirmPos[r]].Extens <> '' Then
        chdirsafe(Dateien[r]^[ListenBegin[r]+SchirmPos[r]].Name+
                  '.'+Dateien[r]^[ListenBegin[r]+SchirmPos[r]].Extens)
        Else chdirsafe(Dateien[r]^[ListenBegin[r]+SchirmPos[r]].Name);

        Lade_Dateien(r);

        If UpDir Then Begin
           FSplit(AktPath,d,nam,ext);
           If Pos('.',Ext)>0 Then Ext:=Copy(Ext,2,Length(Ext)-1);
           AktDir:=0;
           For i:=1 To AnzDateien[r] Do Begin
               With Dateien[r]^[i-1] Do Begin
                    If (Name = nam) And (Extens = Ext) Then AktDir:=i-1;
               End;
           End;
           If AktDir < MaxDateienScreen-1 Then Begin
              ListenBegin[r]:=0;
              SchirmPos[r]:=AktDir;
           End Else Begin
              ListenBegin[r]:=AktDir;
              SchirmPos[r]:=0;
           End;
        End Else Begin
           ListenBegin[r]:=0;
           SchirmPos[r]:=0;
        End;

       End Else Begin
           N:=Dateien[r]^[ListenBegin[r]+SchirmPos[r]].Name;
           E:=Dateien[r]^[ListenBegin[r]+SchirmPos[r]].Extens;
           If (E='BJF') Or (E='PCX') Or (E='LIB') Or (E='VID') Then PicView(n,e);
       End;
End;

Procedure ChangeWindow;
Begin
     Rechts:=Not Rechts;
     GetDir(0,OldPath);
     chdirsafe(OtherPath);
     OtherPath:=OldPath;
End;

Procedure FindeAnfang(Suchen: String);
Var
   i: Word;
   Tmp: String;
Begin
     For i:=0 to AnzDateien[Byte(Rechts)]-1 Do Begin
         Tmp:=Dateien[Byte(Rechts)]^[i].Name+'.'+Dateien[Byte(Rechts)]^[i].Extens;
         If Length(Tmp) >= Length(Suchen) Then
            Tmp:=Copy(Tmp,1,Length(Suchen))
         Else Tmp:='';
         If Tmp = Suchen Then Begin
            If AnzDateien[Byte(Rechts)] <= MaxDateienScreen Then Begin
               ListenBegin[Byte(Rechts)]:=0;
               SchirmPos[Byte(Rechts)]:=i;
            End Else If (AnzDateien[Byte(Rechts)] > MaxDateienScreen) Then
            Begin
                 ListenBegin[Byte(Rechts)]:=i;
                 SchirmPos[Byte(Rechts)]:=0;
            End Else Begin
            End;
            Exit;
         End;
     End;
End;

Procedure IncSuchen(Zeichen: Char);
Begin
     If (Pos(Zeichen,SuchZeichen) > 0) And (Length(Suchen[Byte(Rechts)]) < 12) Then Begin
        Suchen[Byte(Rechts)]:=Suchen[Byte(Rechts)]+Zeichen;
        FindeAnfang(Suchen[Byte(Rechts)]);
     End;
End;

Procedure DecSuchen;
Begin
     If Length(Suchen[Byte(Rechts)]) > 1 Then
        Suchen[Byte(Rechts)]:=Copy(Suchen[Byte(Rechts)],1,Length(Suchen[Byte(Rechts)])-1)
     Else Suchen[Byte(Rechts)]:='';
     FindeAnfang(Suchen[Byte(Rechts)]);
End;

Function FindeMenuPunktNr(SuchNr: Word): Integer;
Var
   i: Word;
Begin
     For i:=0 To AnzMenuPunkteGesamt Do With MenuPunkte[i] Do Begin
         If Nr = SuchNr Then Begin
            FindeMenuPunktNr:=i;
            Exit;
         End;
     End;
     FindeMenuPunktNr:=-1;
End;

Function FindeMenuPunkt(SNr,MenuNr: Word): Integer;
Var
   i: Word;
Begin
     For i:=0 To AnzMenuPunkteGesamt Do With MenuPunkte[i] Do Begin
         If (SubNr = SNr) And (MenuNr = MenuNummer) Then Begin
            FindeMenuPunkt:=i;
            Exit;
         End;
     End;
     FindeMenuPunkt:=-1;
End;

Procedure InitMenu;
Var
   i,i2: Integer;
   Posi: Byte;
   Start: Byte;
   Breite,BreiteGesamt: Byte;
Begin
     Start:=2;
     Breite:=0;
     BreiteGesamt:=0;
     For i:=0 To AnzUnterMenus Do With UnterMenus[i] Do Begin
         Posi:=Pos('~',Cap);
         If Posi > 0 Then Begin
            Delete(Cap,Posi,1);
            Marked:=Posi-1;
            Short:=Cap[Posi];
         End Else Begin
            Marked:=255;
            Short:=#0;
         End;
         BreiteGesamt:=0;
         AnzMenuPunkte:=0;
         For i2:=0 To AnzMenuPunkteGesamt Do With MenuPunkte[i2] Do Begin
             If UnterMenus[i].Nr = SubNr Then Begin
                MenuNummer:=AnzMenuPunkte;
                Inc(AnzMenuPunkte);
                Posi:=Pos('~',Cap);
                If Posi > 0 Then Begin
                   Delete(Cap,Posi,1);
                   Marked:=Posi-1;
                   Short:=Cap[Posi];
                End Else Begin
                   Marked:=255;
                   Short:=#0;
                End;
                Breite:=Length(Cap)+Length(Hot)+4;
                If Breite > BreiteGesamt Then BreiteGesamt:=Breite;
             End;
         End;
         Width:=BreiteGesamt+4;
         x:=Start;
         If x+Width+4 > 79 Then StartX:=75-Width Else StartX:=x-2;
         Inc(Start,Length(Cap)+3);
         AktMenuPunkt:=0;
     End;
     UnterMenuAktiv:=False;
End;

Procedure MaleMenu;
Var
   i: Word;
   a,b: Word;
Begin
     SetColors(MenuVorder,MenuHinter);
     For i:=0 To 79 Do PutChar(i,MenuStart,' ');
     For i:=0 To AnzUnterMenus Do With UnterMenus[i] Do Begin
         PutString(x+1,MenuStart,Cap);
         If Marked < 255 Then Begin
            SetColors(MenuMarkiert,MenuHinter);
            PutChar(x+1+Marked,MenuStart,Short);
            SetColors(MenuVorder,MenuHinter);
         End;
     End;
     SetColors(MenuVorder,MenuBalken);
     AttrLine(UnterMenus[AktUnterMenu].x,MenuStart,Length(UnterMenus[AktUnterMenu].Cap)+2,MenuBalken);
     If UnterMenuAktiv Then With UnterMenus[AktUnterMenu] Do Begin
        SetColors(MenuVorder,MenuHinter);
        Bar(startx,MenuStart+1,startx+Width,MenuStart+1+AnzMenuPunkte+1,' ');
        PutChar(StartX+1,MenuStart+1,'');
        For a:=StartX+2 To StartX+Width-2 Do PutChar(a,MenuStart+1,'');
        PutChar(StartX+Width-1,MenuStart+1,'');
        a:=0;
        For i:=0 To AnzMenuPunkteGesamt Do With MenuPunkte[i] Do Begin
            If SubNr = UnterMenus[AktUnterMenu].Nr Then Begin
               For b:=0 To 1 Do MakeShadow(StartX+Width+b+1,MenuStart+2+a);
               If Cap = '-' Then Begin
                  PutChar(StartX+1,MenuStart+2+a,'');
                  PutChar(StartX+Width-1,MenuStart+2+a,'');
                  For b:=StartX+2 To StartX+Width-2 Do PutChar(b,MenuStart+2+a,'');
               End Else Begin
                  PutChar(StartX+1,MenuStart+2+a,'');
                  PutChar(StartX+Width-1,MenuStart+2+a,'');
                  PutString(StartX+3,MenuStart+2+a,Cap);
                  PutString(StartX+Width-2-Length(Hot),MenuStart+2+a,Hot);
                  If Marked < 255 Then Begin
                     SetColors(MenuMarkiert,MenuHinter);
                     PutChar(StartX+3+Marked,MenuStart+2+a,Short);
                     SetColors(MenuVorder,MenuHinter);
                  End;
                  If Checked Then PutChar(StartX+2,MenuStart+2+a,'');
               End;
               Inc(a);
            End;
        End;
        PutChar(StartX+1,MenuStart+2+AnzMenuPunkte,'');
        For a:=StartX+2 To StartX+Width-2 Do PutChar(a,MenuStart+2+AnzMenuPunkte,'');
        PutChar(StartX+Width-1,MenuStart+2+AnzMenuPunkte,'');
        For b:=0 To 1 Do MakeShadow(StartX+Width+b+1,MenuStart+2+AnzMenuPunkte);
        For b:=0 To Width Do MakeShadow(StartX+b+2,MenuStart+3+AnzMenuPunkte);
        SetColors(MenuVorder,MenuBalken);
        AttrLine(StartX+2,MenuStart+2+AktMenuPunkt,Width-3,MenuBalken);
     End;
End;

Procedure ProgrammBeenden;
Begin
  TextMode(3);
  Color(7,0);
{  chdirsafe('C:\tp7\projekte\bjc');}
  BufToScreen(@HardCopy);
  CursorOnOff(True);
  GoToXY(AltX,AltY);
  Writeln;
  Writeln('BJ-Commander V'+ver+'.');
  Writeln('Danke!');
  Halt;
End;

Procedure SetSortLeft(Sort: Byte);
Begin
     Case Sort Of
          SortName: Begin
             MenuPunkte[FindeMenuPunktNr(PNameL)].Checked:=True;
             MenuPunkte[FindeMenuPunktNr(PExtensL)].Checked:=False;
             MenuPunkte[FindeMenuPunktNr(PSizeL)].Checked:=False;
          End;
          SortExtens: Begin
             MenuPunkte[FindeMenuPunktNr(PNameL)].Checked:=False;
             MenuPunkte[FindeMenuPunktNr(PExtensL)].Checked:=True;
             MenuPunkte[FindeMenuPunktNr(PSizeL)].Checked:=False;
          End;
          SortSize: Begin
             MenuPunkte[FindeMenuPunktNr(PNameL)].Checked:=False;
             MenuPunkte[FindeMenuPunktNr(PExtensL)].Checked:=False;
             MenuPunkte[FindeMenuPunktNr(PSizeL)].Checked:=True;
          End;
     End;
     Sortieren[0]:=Sort;
     Lade_Dateien(0);
End;

Procedure SetSortRight(Sort: Byte);
Begin
     Case Sort Of
          SortName: Begin
             MenuPunkte[FindeMenuPunktNr(PNameR)].Checked:=True;
             MenuPunkte[FindeMenuPunktNr(PExtensR)].Checked:=False;
             MenuPunkte[FindeMenuPunktNr(PSizeR)].Checked:=False;
          End;
          SortExtens: Begin
             MenuPunkte[FindeMenuPunktNr(PNameR)].Checked:=False;
             MenuPunkte[FindeMenuPunktNr(PExtensR)].Checked:=True;
             MenuPunkte[FindeMenuPunktNr(PSizeR)].Checked:=False;
          End;
          SortSize: Begin
             MenuPunkte[FindeMenuPunktNr(PNameR)].Checked:=False;
             MenuPunkte[FindeMenuPunktNr(PExtensR)].Checked:=False;
             MenuPunkte[FindeMenuPunktNr(PSizeR)].Checked:=True;
          End;
     End;
     Sortieren[1]:=Sort;
     Lade_Dateien(1);
End;

Procedure NeuesVerz;
Var
   Verz: String;
Begin
     SetColors(SchriftNormal,FensterNormal);
     Fenster(10,10,70,13,' Neues Verzeichnis: ',True);
     PutString(12,11,'Name des neuen Verzeichnisses:');
     Verz:=EingabeZeile(12,12,57,'');
     If Verz = '' Then Exit;
     Dummy:=IOresult;
     MkDir(Verz);
     If IOResult <> 0 Then Begin
        FehlerMeldung('Fehler beim Erstellen von '+Verz+'.');
     End;
     Lade_Dateien(0);
     Lade_Dateien(1);
End;

Procedure MarkAll;
Var
   i: Word;
   r: Byte;
Begin
     r:=Byte(Rechts);
     For i:=0 To AnzDateien[r]-1 Do Begin
         If Dateien[r]^[i].Name <> '..' Then
         Dateien[r]^[i].Marker:=True;
     End;
End;

Procedure MarkNone;
Var
   i: Word;
   r: Byte;
Begin
     r:=Byte(Rechts);
     For i:=0 To AnzDateien[r]-1 Do Begin
         If Dateien[r]^[i].Name <> '..' Then
         Dateien[r]^[i].Marker:=False;
     End;
End;

Procedure MarkInvert;
Var
   i: Word;
   r: Byte;
Begin
     r:=Byte(Rechts);
     For i:=0 To AnzDateien[r]-1 Do Begin
         If Dateien[r]^[i].Name <> '..' Then
         Dateien[r]^[i].Marker:=Not Dateien[r]^[i].Marker;
     End;
End;

Procedure SetAttr(TheAttr: Word);
Var
   Mark: Boolean;
   i: Word;
   r: Byte;
   Ch: Char;
   Dat: String;
   Result: Boolean;
Begin
     r:=Byte(Rechts);
     Mark:=False;
     For i:=0 To AnzDateien[r]-1 Do If Dateien[r]^[i].Marker Then Mark:=True;
     If Mark Then Begin
        SetColors(White,Red);
        Fenster(5,10,75,16,' Warnung: ',True);
        PutString(7,11,'Sie haben mehrere Dateien ausgewhlt.');
        PutString(7,12,'Sollen die Flags aller markierter Dateien gendert werden?');
        ShowTBuf;
        Auswahl_Elemente[0]:='  Ja  ';
        AusWahl_Elemente[1]:=' Nein ';
        Dummy:=AusWahlFeld(35,14,3,2,White,Red,Black);
        If Dummy <> 0 Then Exit;
     End Else Dateien[r]^[ListenBegin[r]+SchirmPos[r]].Marker:=True;
     For i:=0 to AnzDateien[r]-1 Do With Dateien[r]^[i] Do Begin
        If Marker Then Begin
           Dat:=MakeName(Name,Extens);
           Result:=True;
           Case TheAttr Of
                PSetRead: Result:=SetFileAttr(Dat,Attr Or ReadOnly);
                PSetHidden: Result:=SetFileAttr(Dat,Attr Or Hidden);
                PSetSystem: Result:=SetFileAttr(Dat,Attr Or SysFile);
                PSetArchive: Result:=SetFileAttr(Dat,Attr Or Archive);
                PClrRead: Result:=SetFileAttr(Dat,Attr And (Not ReadOnly));
                PClrHidden: Result:=SetFileAttr(Dat,Attr And (Not Hidden));
                PClrSystem: Result:=SetFileAttr(Dat,Attr And (Not sysFile));
                PClrArchive: Result:=SetFileAttr(Dat,Attr And (Not Archive));
           End;
           If Result <> True Then Exit;
        End;
     End;
     Lade_Dateien(0);
     Lade_Dateien(1);
End;

Procedure FileInfo;
Var
   r: Byte;
   Size,Dirs,Files: Longint;

Procedure CountDir(DirName: String; Var Size,Dirs,Files: Longint);
Var
   Tmp: SearchRec;
Begin
     ChDirSafe(DirName);
     dummy:=IOResult;
     FindFirst('*.*',AnyFile,Tmp);
     While DosError = 0 Do Begin
           If (Tmp.Name <> '..') And (Tmp.Name <> '.') And ((Tmp.Attr And Directory) <> 0) Then Begin
              Inc(Dirs);
              CountDir(Tmp.Name,Size,Dirs,Files);
           End;
           FindNext(Tmp);
     End;
     FindFirst(DateiFilter[r],Anyfile Xor Directory,Tmp);
     While DosError = 0 Do Begin
           If ((Tmp.Attr And VolumeID) = 0) Then Begin
              Inc(Files);
              Inc(Size,Tmp.Size);
           End;
           FindNext(Tmp);
     End;
     ChDirSafe('..');
End;

Begin
     Size:=0;
     Dirs:=0;
     Files:=0;
     r:=Byte(Rechts);
     With Dateien[r]^[ListenBegin[r]+SchirmPos[r]] Do Begin
          If Name = '..' Then Exit;
          If (Attr And Directory) <> 0 Then Begin
             SetColors(SchriftNormal,FensterNormal);
             Fenster(30,11,50,13,'',True);
             PutString(32,12,'Zhle...');
             ShowTBuf;
             CountDir(MakeName(Name,Extens),Size,Dirs,Files);
             Fenster(20,9,60,18,' Verzeichnis-Info ',True);
             PutString(34,11,'Name:');
             PutString(25,12,'Verzeichnisse:');
             PutString(31,13,'Dateien:');
             PutString(33,14,'Gre:');
             SetColors(Yellow,FensterNormal);
             PutString(40,11,MakeName(Name,Extens));
             PutString(40,12,Formatted(Dirs));
             PutString(40,13,Formatted(files));
             PutString(40,14,Formatted(Size));
             Auswahl_Elemente[0]:=' OK ';
             Dummy:=AuswahlFeld(39,16,0,1,SchriftNormal,FensterNormal,Black);
          End;
     End;
End;

Procedure DriveInfo;
Var
   Frei,Belegt,Gesamt: Longint;
   Lw: String;
Begin
     GetDir(0,Lw);
     Lw:=Copy(Lw,1,2);
     Gesamt:=DiskSize(0);
     If Gesamt < 0 Then Begin
        FehlerMeldung('Fehler beim Lesen von Laufwerk '+Lw+'.');
        Exit;
     End;
     Frei:=DiskFree(0);
     Belegt:=Gesamt-Frei;
     SetColors(SchriftNormal,FensterNormal);
     Fenster(20,9,60,18,' Laufwerks-Info ',True);
     PutString(30,11,'Laufwerk:');
     PutString(29,12,'Kapazitt:');
     PutString(32,13,'Belegt:');
     PutString(34,14,'Frei:');
     SetColors(Yellow,FensterNormal);
     PutString(40,11,Lw);
     PutString(40,12,Formatted(Gesamt));
     PutString(40,13,Formatted(Belegt));
     PutString(40,14,Formatted(Frei));
     ShowTBuf;
     Auswahl_Elemente[0]:=' OK ';
     Dummy:=AuswahlFeld(38,16,0,1,White,LightGray,Black);
End;

Procedure About;
Var
   Info: Array[0..2] Of String;
   i: Byte;
Begin
     Info[0]:='BJ-Commander V'+ver;
     Info[1]:='Programmiert von Jan Strter und Benjamin Bockmhl';
     Info[2]:='Copyright by BJ-Studios 1997. All rights reserved.';
     SetColors(SchriftNormal,FensterNormal);
     Fenster(12,9,68,17,' ber... ',True);
     For i:=0 To 2 Do Begin
         PutString(GetCentered(12,68,Length(Info[i])),11+i,Info[i]);
     End;
     ShowTBuf;
     Auswahl_Elemente[0]:=' OK ';
     Dummy:=AuswahlFeld(39,15,0,1,SchriftNormal,FensterNormal,Black);
End;

Procedure TextView;
Const
  Lines = 5000;
Type
  T = Array[0..65534] Of Char; { Hier kommt der Text rein }
  Z = Array[0..Lines] Of Word; { Hier wird gespeichert, welche Zeile wo beginnt }
  L = Array[0..Lines] Of Byte; { "    "    "          , wie lang eine Zeile ist }
Var
   f: Text;
   x,y: Longint;
   Size: Longint;
   Text: ^T;
   Zeilen: ^Z;
   Laenge: ^L;
   AnzZeilen: Longint;
   i: longint;
   Zeile: String;
   Ch: Char;
   a,b: longint;
Begin
     { Speicher berprfen und belegen }
     If MaxAvail < SizeOf(T)+SizeOf(Z)+SizeOf(L) Then Begin
        FehlerMeldung('Nicht gengend Speicher, um den Text anzuzeigen.');
        Exit;
     End;
     New(Text);
     New(Zeilen);
     New(Laenge);

     { Variablen initialisieren }
     FillChar(Text^,SizeOf(T),' ');
     FillChar(Zeilen^,SizeOf(Z),0);
     FillChar(Laenge^,SizeOf(L),0);
     x:=0;
     y:=0;
     Size:=0;
     AnzZeilen:=0;

     { Daten einlesen }
     i:=ListenBegin[Byte(Rechts)]+SchirmPos[Byte(Rechts)];
     If (Dateien[Byte(Rechts)]^[i].Attr And Directory) = 0 Then Begin
        Assign(f,MakeName(Dateien[Byte(Rechts)]^[i].Name,Dateien[Byte(Rechts)]^[i].Extens));
        Dummy:=IOResult;
        Reset(f);
        If IOResult = 0 Then Begin

           { Text Zeile fr Zeile lesen }
           While (Not Eof(f)) Do Begin
                 ReadLn(f,Zeile);
                 If IOresult <> 0 Then Begin
                    FehlerMeldung('Fehler beim Lesen der Datei.');
                    Break;
                 End;
                 If (AnzZeilen >= Lines) Or (Size+Length(Zeile) > SizeOf(T)) Then Begin
                    FehlerMeldung('Nicht gengend Speicher, um die Datei ganz anzuzeigen.');
                    Break;
                 End;
                 Move(Zeile[1],Ptr(Seg(Text^),Ofs(Text^)+Size)^,Length(Zeile));
                 Zeilen^[AnzZeilen]:=Size;
                 Laenge^[AnzZeilen]:=Length(Zeile);
                 Inc(AnzZeilen);
                 Inc(Size,Length(Zeile));
           End;

           { Datei wird nicht mehr gebraucht. Schlieen! }
           Close(f);

           Repeat
                 SetColors(White,Blue);
                 Fenster(0,0,79,24,' Textbetrachter ',False);
                 PutString(1,0,' '+Stri(y+1)+':'+Stri(x+1)+' ');
                 SetColors(Yellow,Blue);
                 For b:=1 To 23 Do Begin
                     If b <= AnzZeilen Then Begin
                        For a:=1 To 78 Do Begin
                            If (x+a-1 <= (Laenge^[b+y-1]-1)) Then
                            PutChar(a,b,Chr(Mem[Seg(Text^):Ofs(Text^)+Zeilen^[b+y-1]+a+x-1]));
                        End;
                     End;
                 End;
                 ShowTBuf;
                 Ch:=ReadKey;
                 If Ch = #0 Then Begin
                    Ch:=ReadKey;
                    Case Ch Of
                         Taste_PfeilRechts: If x<175 Then Inc(x);
                         Taste_PfeilLinks: If x>0 Then Dec(x);
                         Taste_PfeilUnten: If y<AnzZeilen-23 Then Inc(y);
                         Taste_PfeilOben: If y>0 Then Dec(y);
                         Taste_SeiteOben: Begin
                                               Dec(y,23);
                                               If y < 0 Then y:=0;
                                          End;
                         Taste_SeiteUnten: Begin
                                               Inc(y,23);
                                               If y > AnzZeilen-23 Then y:=AnzZeilen-23;
                                               If y<0 Then y:=0;
                                          End;
                         Taste_Pos1: Begin
                                          y:=0;
                                          x:=0;
                                     End;
                         Taste_Ende: Begin
                                          y:=AnzZeilen-23;
                                          If y<0 Then y:=0;
                                      End;
                    End;
                 End;
           Until Ch = #27;

        End Else Begin
            FehlerMeldung('Fehler beim ffnen der Datei.');
        End;
     End;

     { Speicher wieder freigeben }
     Dispose(Laenge);
     Dispose(Zeilen);
     Dispose(Text);
End;

Procedure MakeList;
Var
   r: Byte;
   i: Word;
   Ok: Boolean;
   Datei: String;
   f: Text;
Begin
     r:=Byte(Rechts);
     Ok:=False;
     For i:=0 To AnzDateien[r]-1 Do Begin
         If Dateien[r]^[i].Marker Then Ok:=True;
     End;
     If (Not Ok) Then Begin
        FehlerMeldung('Keine Dateien markiert.');
        Exit;
     End;
     SetColors(SchriftNormal,FensterNormal);
     Fenster(20,10,60,13,' LST-Datei erstellen: ',True);
     PutString(22,11,'Dateiliste sichern in:');
     ShowTBuf;
     Datei:=EingabeZeile(22,12,37,'');
     If Datei = '' Then Exit;
     Dummy:=IOResult;
     Assign(f,Datei);
     ReWrite(f);
     If IOResult <> 0 Then Begin
        FehlerMeldung('Fehler beim Erstellen von '+Datei+'.');
        Exit;
     End;
     For i:=0 To AnzDateien[r]-1 Do With Dateien[r]^[i] Do Begin
         If Marker Then WriteLn(f,MakeName(Name,Extens));
         If IOResult <> 0 Then Begin
            Close(f);
            Dummy:=IOResult;
            FehlerMeldung('Fehler beim Schreiben in '+Datei+'.');
            Exit;
         End;
     End;
     Close(f);
     Dummy:=IOResult;
End;

Procedure GroupSelect(DialogBox, Select: Boolean);
Var
   r: Byte;
   i: Word;
   Tmp: SearchRec;
   TmpMask: String[12];
   Action: String;
Begin
     r:=Byte(Rechts);
     If Select Then Action:='Gruppe auswhlen:' Else Action:='Gruppenauswahl rckgngig:';
     If DialogBox Then Begin
        SetColors(SchriftNormal,FensterNormal);
        Fenster(40-Length(Action) Div 2-2,10,40+Length(Action) Div 2+2,15,' Auswahl: ',True);
        PutString(GetCentered(1,80,Length(Action)),12,Action);
        PutChar(33,13,'[');
        PutChar(47,13,']');
        TmpMask:=EingabeZeile(34,13,13,GroupMask);
        If TmpMask = '' Then Exit;
        If (pos('\',TmpMask)>0) or (pos(':',TmpMask)>0) Then Begin
           FehlerMeldung('Laufwerks- und/oder Verzeichnis-Angaben sind nicht erlaubt.');
           Exit;
        End;
        GroupMask:=TmpMask;
     End;
     FindFirst(GroupMask,Anyfile,Tmp);
     While DosError = 0 Do Begin
           For i:=0 To AnzDateien[r]-1 Do Begin
               With Dateien[r]^[i] Do Begin
                    If Name <> '..' Then Begin
                       If MakeName(Name,Extens) = Tmp.Name Then Marker:=Select;
                    End;
               End;
           End;
           FindNext(Tmp);
     End;
End;

Procedure FuehreKommandoAus;
Begin
     Paint_Desktop;
     ShowTBuf;
     Case AktKommando Of
          PBeenden: ProgrammBeenden;
          PDriveL: ChangeLW(False);
          PDriveR: ChangeLW(True);
          PNameL: SetSortLeft(SortName);
          PExtensL: SetSortLeft(SortExtens);
          PSizeL: SetSortLeft(SortSize);
          PNameR: SetSortRight(SortName);
          PExtensR: SetSortRight(SortExtens);
          PSizeR: SetSortRight(SortSize);
          PFilterL: Filter(0);
          PFilterR: Filter(1);
          PNoFilterL: NoFilter(0);
          PNoFilterR: NoFilter(1);
          PCopy: KopiereAlles(False);
          PMove: KopiereAlles(True);
          PMarkAll: MarkAll;
          PMarkNone: MarkNone;
          PMarkInvert: MarkInvert;
          PRename: Umbenennen(MakeName(Dateien[Byte(Rechts)]^[ListenBegin[Byte(Rechts)]+Schirmpos[Byte(Rechts)]].Name,
                                       Dateien[Byte(Rechts)]^[ListenBegin[Byte(Rechts)]+Schirmpos[Byte(Rechts)]].Extens));
          PDelete: LoescheAlles;
          PNewDir: NeuesVerz;
          PActL: Begin
                    SchirmPos[0]:=0;
                    ListenBegin[0]:=0;
                    Lade_Dateien(0);
                 End;
          PActR: Begin
                    SchirmPos[1]:=0;
                    ListenBegin[1]:=0;
                    Lade_Dateien(1);
                 End;
          PTextView: TextView;
          PFileInfo: FileInfo;
          PDriveInfo: DriveInfo;
          PPicView: ChangeDir;
          PAbout: About;
          PMakeList: MakeList;
          PGrpSel: GroupSelect(True,True);
          PGrpUnSel: GroupSelect(True,False);
          PGrpRepeat: GroupSelect(False,True);
          Else Begin
             SetAttr(AktKommando);
          End;
     End;
End;

Procedure TastaturKommando(Ch: Char);
Var
   i: Integer;
Begin
     For i:=0 To AnzMenuPunkteGesamt Do With MenuPunkte[i] Do Begin
         If Key = Ch Then Begin
            AktKommando:=Nr;
            FuehreKommandoAus;
            Exit;
         End;
     End;
     AktKommando:=-1;
End;

Procedure Menu;
Var
   Ch: Char;

Procedure Runter;
Begin
     With UnterMenus[AktUnterMenu] Do Begin
          If AktMenuPunkt < AnzMenuPunkte-1 Then Inc(AktMenuPunkt) Else
             AktMenuPunkt:=0;
           If MenuPunkte[FindeMenuPunkt(Nr,AktMenuPunkt)].Cap = '-' Then Runter;
     End;
End;

Procedure Hoch;
Begin
     With UnterMenus[AktUnterMenu] Do Begin
          If AktMenuPunkt > 0 Then Dec(AktMenuPunkt) Else
             AktMenuPunkt:=AnzMenuPunkte-1;
           If MenuPunkte[FindeMenuPunkt(Nr,AktMenuPunkt)].Cap = '-' Then Hoch;
     End;
End;

Procedure SucheBuchstabeUnterMenu(Zeichen: Char);
Var
   i: Word;
Begin
     For i:=0 To AnzUnterMenus Do With UnterMenus[i] Do Begin
         If UpCaseDeu(Short) = UpCaseDeu(Zeichen) Then Begin
            AktUnterMenu:=i;
            UnterMenuAktiv:=True;
         End;
     End;
End;

Procedure MenuKommando;
Begin
     AktKommando:=MenuPunkte[FindeMenuPunkt(UnterMenus[AktUnterMenu].Nr,UnterMenus[AktUnterMenu].AktMenuPunkt)].Nr;
     FuehreKommandoAus;
     Ch:=#27;
End;

Procedure SucheBuchstabeMenuPunkt(Zeichen: Char);
Var
   i: Word;
Begin
     For i:=0 To UnterMenus[AktUnterMenu].AnzMenuPunkte-1 Do
         With MenuPunkte[FindeMenuPunkt(UnterMenus[AktUnterMenu].Nr,i)] Do Begin
         If UpCaseDeu(Short) = UpCaseDeu(Zeichen) Then Begin
            UnterMenus[AktUnterMenu].AktMenuPunkt:=i;
            MenuKommando;
         End;
     End;
End;

Begin
     Ch:=#0;
     If (Not Rechts) Then AktUnterMenu:=0 Else AktUnterMenu:=AnzUnterMenus;
     UnterMenuAktiv:=False;
     Repeat
           Paint_Desktop;
           MaleMenu;
           If KeyPressed Then begin
              Ch:=ReadKey;
              If Ch = #0 Then Begin
                 Ch:=ReadKey;
                 Case Ch Of
                      Taste_PfeilLinks: If AktUnterMenu > 0 Then Dec(AktUnterMenu) Else AktUnterMenu:=AnzUnterMenus;
                      Taste_PfeilRechts: If AktUnterMenu < AnzUnterMenus Then Inc(AktUnterMenu) Else AktUnterMenu:=0;
                      Taste_PfeilUnten:If Not UnterMenuAktiv Then UnterMenuAktiv:=True Else Runter;
                      Taste_PfeilOben: If UnterMenuAktiv Then Hoch;
                      Taste_Pos1: UnterMenus[AktUnterMenu].AktMenuPunkt:=0;
                      Taste_Ende: UnterMenus[AktUnterMenu].AktMenuPunkt:=UnterMenus[AktUnterMenu].AnzMenuPunkte-1;
                 End;
              End Else Begin
                Case Ch Of
                    #13,#32: If Not UnterMenuAktiv Then UnterMenuAktiv:=True Else MenuKommando;
                Else
                    If UnterMenuAktiv = False Then SucheBuchstabeUnterMenu(Ch) Else
                       SucheBuchstabeMenuPunkt(Ch);
                End;
              End;
           End;
           ShowTBuf;
     Until Ch = #27;
End;

Procedure Start_Program;
  Var
    ch:Char;
  Begin
    Writeln('BJ-Commander Version '+Ver+'. Copyright (c) 1997 by BJ-Studios');
    Lade_Dateien(0);
    Lade_Dateien(1);
    InitMenu;
    Paint_Desktop;
    ShowTBuf;
    Repeat
      If KeyPressed Then Begin
         ch:=Readkey;
         If ch=#0 Then Begin
           ch:=Readkey;
           Case ch Of
             Taste_PfeilOben:ScrollUp;
             Taste_PfeilUnten:ScrollDown;
             Taste_Pos1:Pos1;
             Taste_Ende:Ende;
             Taste_SeiteOben: PageUp;
             Taste_SeiteUnten: PageDown;
             Taste_F10: Menu;
             Else TastaturKommando(Ch);
           End;
         End Else Begin
           Ch:=UpCaseDeu(Ch);
           Case ch of
             Taste_Tab :ChangeWindow;
             Taste_Eingabe:ChangeDir;
             Taste_Leer:Markieren;
             Taste_Loeschen:DecSuchen;
             Else IncSuchen(Ch)
           End;
         End;
      End;
      Paint_Desktop;
      ShowTBuf;
    Until False;
  End;

Begin
  {$I-}
  Init_Vars;
  Start_Program;
  {$I+}
End.